function tendKey(source) {
    var self = this;

    self.ID = 0;
    self.Code = '';
    self.Number = '';
    self.Description = '';
    self.Cash = '';
    self.FullDescription = '';
    self.AllowChange = false;
    self.RefDescription = '';
    self.Symbol = '';
    self.IsCard = false;
    self.CashCount = false;
    self.CashType = false;
    self.ExchangeRate = 0.0
    self.Disable = false;
    self.BankDeposit = false;
    self.GiftCard = false;
    self.Recorded = 0.00;
    self.ExchAmtRecorded = 0.00;
    self.version = {
        Number: "1.0.0.0"
    }

    /// <summary>
    /// Fill the object data from a json
    /// </summary>
    /// <returns type=""></returns>
    var init = function (obj) {

        if (!_.isObject(obj))
            obj = JSON.parse(obj);

        if (obj != null) {
            self.ID             = obj.ID             ;
            self.Code           = obj.Code           ;
            self.Number         = obj.Number         ;
            self.Description    = obj.Description    ;
            self.Cash           = obj.Cash           ;
            self.FullDescription= obj.FullDescription;
            self.AllowChange    = obj.AllowChange    ;
            self.RefDescription = obj.RefDescription ;
            self.Symbol         = obj.Symbol         ;
            self.IsCard         = obj.IsCard         ;
            self.CashCount      = obj.CashCount      ;
            self.CashType       = obj.CashType       ;
            self.ExchangeRate   = obj.ExchangeRate   ;
            self.Disable        = obj.Disable        ;
            self.BankDeposit    = obj.BankDeposit    ;
            self.GiftCard       = obj.GiftCard       ;
            self.version        = obj.version        ;
            self.Recorded       = obj.Recorded       ;
            self.ExchAmtRecorded= obj.ExchAmtRecorded;
        }
        
    };

    if (source != null)
        init(source);

    return self;
}