var module = angular.module('aralco.physicalcount');
 module.factory('departmentFctr', ['$q', '$http','ImgService','$timeout', function ($q, $http,ImgService,$timeout) {
        var self = this;
        function isLoadDepartmentImages(_department){
                  $timeout(function(){
                      _.each(_department,function(department){
                          //if(department.Image ==='./img/logo-barcode.png'){
                          if(_.isEmpty(department.Image)){
                              getDepartmentPictures(department.ID).then(function(image){
                                      department.Image = image[0].value;
                              },function(error){
                                  console.log('Dep Image Not Fetched');
                              });

                          }
                      });
                  },100)
              };


        function getDepartments(){
            var def= $q.defer();
            var url = $f.serviceUrl +"department/get";
            var req = {
                method: 'get',
                url: url
            };

            $http(req).
                success(function (data, status, headers, config) {
                    console.log("Pos Departments Fetched successfully");
                    def.resolve(data)
                }).
                error(function (data, status) {
                    console.log("Pos Departments Not FETCHED");
                    def.reject(data, status);
                });
            return def.promise;
        }
        var getDepartmentPictures = function (id) {
            /// <summary>
            /// Get the main product picture
            /// </summary>
            /// <param name="id"></param>
            /// <returns type=""></returns>
            type = 5; //default is product

            var req = ImgService.SearchParam;
            req.input = id;
            req.Type = type;

            return ImgService.Search(req);
        };
        function getProductsByID(id){
            var def= $q.defer();
            var url = $f.serviceUrl + "Product/Search/{input}/6";
            url = url.replace('{input}', id);
            var options = "store={store}&sort={sort}&maxitems={maxitems}&page={page}&ForceLoad={ForceLoad}&ExcludeDeactivated={ExcludeDeactivated}";
            options = options.replace('{sort}', req.sort)
                            .replace('{maxitems}', req.maxitems)
                            .replace("{page}", req.page)
                            .replace("{ForceLoad}", req.forceLoad)
                            .replace("{ExcludeDeactivated}", req.ExcludeDeactivated)
                            .replace("{store}", req.store);
            var req = {
                method: 'get',
                url: url
            };

            $http(req).
                success(function (data, status, headers, config) {
                    console.log("POS Products Fetched successfully");
                    console.log(data);
                    def.resolve(data)
                }).
                error(function (data, status) {
                    console.log("Pos Products Not FETCHED");
                    def.reject(data, status);
                });


            return def.promise;
        }
        self.$LoadDepartments = getDepartments;
        self.$LoadProducts = getProductsByID;
        self.$GetDepartmentPicture = getDepartmentPictures;
        self.$LoadDepartmentImages = isLoadDepartmentImages;
        return self;
    }]);