﻿/// <reference path="../../js/aaralco.mobile.fwaralco.mobile.fw.js" />
(function () {
    'use strict';

    var module = angular.module('aralco.dimension', []);

    module.factory('dimFctr', ['$http', '$q', function ($http, $q) {
        var self = this;

        var _getDimension =function (id, ForceLoad)
        {
            /// <summary>
            /// Return the detailed dimension for the specified id
            /// </summary>
            /// <param name="id"></param>
            /// <param name="ForceLoad"></param>
            /// <returns type=""></returns>
            var def = $q.defer();

            ForceLoad = ForceLoad || $f.ForceLoad;
            var url = "Dimension/Detail/{ID}?ForceLoad={ForceLoad}";

            url = url.replace("{ID}", id || '').replace("{ForceLoad}", $f.ForceLoad);

            url = $f.serviceUrl + url;

            var httpreq = {
                method: 'get',
                url: url
            }

            $http(httpreq).success(
                function (data, status, headers, config) {
                    def.resolve(data);
                }).error(
            function (data, status, headers, config) {
                def.reject(data, status);
            });

            return def.promise;
        }

        self.$get = _getDimension;


        return self;
    }
    ])

})();