﻿/// <reference path="../../js/models/scan.js" />
(function () {

    'use strict';
    var module = angular.module('aralco.physicalcount', ['ionic', 'aralco.database', 'aralco.sql', 'aralco.product']);

    module.config(['$stateProvider', '$urlRouterProvider', function ($stateProvider, $urlRouterProvider) {
        // Each tab has its own nav history stack:
        $stateProvider.state('tab.physicalcount', {
            url: '/physicalcount',
            cache:false,
            views: {
                'tab-inventory': {
                    templateUrl: 'modules/inventory/physical_count/templates/tab-physicalcount.html',
                    controller: 'PhysicalCountListCtrl'
                }
            }
        });

        $stateProvider.state('tab.physicalcount-snapshots', {
            url: '/physicalcount/:pcid',
            views: {
                'tab-inventory': {
                    templateUrl: 'modules/inventory/physical_count/templates/tab-physicalcount-snapshot.html',
                    controller: 'SnapshotListCtrl'
                }
            }
        });

        $stateProvider.state('tab.physicalcount-scan', {
            url: '/product/:pcid/:sid',
            views: {
                'tab-inventory': {
                    templateUrl: 'modules/inventory/physical_count/templates/tab-snapshot.html',
                    controller: 'PhysicalCountCtrl'
                }
            }
        });
    }]);

}
)();