﻿(function () {
    'use strict';

    var module = angular.module('aralco.physicalcount');
    module.controller('PhysicalCountListCtrl',['$rootScope','$scope', '$q', '$ionicSideMenuDelegate', '$ionicLoading', 'physicalCountFctr', 'popupFctr','localScanService','$timeout',
    function ($rootScope,$scope, $q, $ionicSideMenuDelegate, $ionicLoading, physicalCountFctr, popupFctr,localScanService,$timeout) {   
            init();
            $scope.Search = function () {
                $ionicLoading.show({
                    template: 'Loading...'
                });
                physicalCountFctr.PhysicalCount.$search($scope.param.searchTerm).then(function (data) {
                    $ionicLoading.hide();
                    $scope.items = data;
                    if (_.isEmpty(data)) {
                        popupFctr.alert('No results found', 'No results found for "' + $scope.param.searchTerm + '"');
                    }
                });
            };
            function init() {
                $ionicLoading.show({
                    template: 'wait ...'
                });
                localScanService.CheckPendingScans(95).then(function (data) 
                {
                    if(data!=null){
                        $timeout(function(){
                            // $ionicLoading.hide();
                            setTimeout($ionicLoading.hide, 100);
                            window.location.href= '#/tab/product/0/'+data;
                        }, 2000);
                    } else {
                        $scope.param = {
                            searchTerm: ''
                        };
                        $scope.items = [];
                        //$ionicLoading.hide();
                        setTimeout($ionicLoading.hide, 100);
                    }
                }, function (e, ex) {
                    throw ex;
                }).finally(function () {
                    //$ionicLoading.hide();
                    setTimeout($ionicLoading.hide, 100);
                });  
              
            }
      }]);
})();
