angular.module('aralco.productsDetails.controllers')
 .controller('DescPosCtrl', ['productDetailsDataFctr','$http','$q','$scope', '$state','errorFctr', '$ionicSideMenuDelegate', '$ionicLoading', '$filter', '$ionicModal',
              function (productDetailsDataFctr,$http,$q, $scope, $state, errorFctr,$ionicSideMenuDelegate, $ionicLoading, $filter, $ionicModal) {


	$ionicModal.fromTemplateUrl('modules/product_details/templates/pos-options-modal.html', {
	    scope: $scope
  	}).then(function(modal) {
    	$scope.posOptionsModal = modal;
  	});
	$scope.openPosOptions = function(){
		$scope.posOptionsModal.show();
	}
	$scope.closePosOptions = function(){
		$scope.posOptionsModal.hide();
	}

	$ionicModal.fromTemplateUrl('modules/product_details/templates/product-rental-modal.html', {
	    scope: $scope
  	}).then(function(modal) {
    	$scope.productRentalModal = modal;
  	});
	$scope.openProductRental = function(){
		$scope.productRentalModal.show();
	}
	$scope.closeProductRental = function(){
		$scope.productRentalModal.hide();
	}

	$ionicModal.fromTemplateUrl('modules/product_details/templates/accompanying-product-modal.html', {
	    scope: $scope
  	}).then(function(modal) {
    	$scope.accompanyingProductsModal = modal;
  	});
	$scope.openAccompanyingProducts = function(){
		$scope.accompanyingProductsModal.show();
	}
	$scope.closeAccompanyingProducts = function(){
		$scope.accompanyingProductsModal.hide();
	}

	$ionicModal.fromTemplateUrl('modules/product_details/templates/quantity-discount-group-modal.html', {
	    scope: $scope
  	}).then(function(modal) {
    	$scope.quantityDiscountGroupModal = modal;
  	});
	$scope.openQuantityDiscountGroup = function(){
		$scope.quantityDiscountGroupModal.show();
	}
	$scope.closeQuantityDiscountGroup = function(){
		$scope.quantityDiscountGroupModal.hide();
	}
	function descPointPlan() {
                    var def = $q.defer();
                    var url = $f.serviceUrl + "/points/getplans";
                    var req = {
                        method: 'get',
                        url: url
                    };
                    errorFctr.specificallyHandled(function () {
                        return $http(req)
                            .then(function (data) {
                                def.resolve(data.data);
                                $scope.descPointPlanDatas=data.data;
                                  var pointplanid = productDetailsDataFctr.getProductDetails().PointPlanID;
                                  var isObject = _.where($scope.descPointPlanDatas, {ID: pointplanid});
                                     if(isObject.length > 0)
                                         $scope.filterdescPointPlanDatas =  isObject.Code;
                                    else
                                       $scope.filterdescPointPlanDatas =  $scope.descPointPlanDatas[0].Code;
                            }, function (error) {
                                def.reject(error);
                            });
                    });

                    return def.promise;
      }

      function descPrinterGroup() {
                    var def = $q.defer();
                    var url = $f.serviceUrl + "/group/getprinters";
                    var req = {
                        method: 'get',
                        url: url
                    };
                    errorFctr.specificallyHandled(function () {
                        return $http(req)
                            .then(function (data) {
                                def.resolve(data.data);
                                $scope.descPrinterGroupDatas=data.data;
                                var printergroupid = productDetailsDataFctr.getProductDetails().PrinterGroupID;
                                var isObject = _.where($scope.descPrinterGroupDatas, {ID: printergroupid})
                                  if(isObject.length > 0)
                                    $scope.filterdescPrinterGroupDatas =  isObject.Name;
                                  else
                                    $scope.filterdescPrinterGroupDatas =  $scope.descPrinterGroupDatas[0].Name;

                            }, function (error) {
                                def.reject(error);
                            });
                    });

                    return def.promise;
      }
      descPrinterGroup();
      descPointPlan();
      $scope.productdetails= productDetailsDataFctr.getProductDetails();
      $scope.POSAlertFromDate = new Date($scope.productdetails.POS.AlertFromDate);
      $scope.POSAlertToDate = new Date($scope.productdetails.POS.AlertToDate);

      $scope.nextView = function(){
         $state.go('tab.pic-sound');
         productDetailsDataFctr.setNextViewCountForBack();
     }

     $scope.previousView = function(){
       $state.go('tab.grouping');
      productDetailsDataFctr.setPreviousViewCountForBack();
     }
    $scope.searchproductcode = productDetailsDataFctr.getProductNameAndCode(); 
}]);
