angular.module('aralco.productsDetails.controllers')
.controller('OrderingCtrl', ['productDetailsDataFctr','$q','$http','errorFctr','$scope', '$state', '$ionicSideMenuDelegate', '$ionicLoading', '$filter', '$ionicPopover', '$ionicModal','localStorageService',
        function (productDetailsDataFctr,$q,$http,errorFctr,$scope, $state, $ionicSideMenuDelegate, $ionicLoading, $filter, $ionicPopover, $ionicModal,localStorageService) {


	$ionicModal.fromTemplateUrl('modules/product_details/templates/high-volume-modal.html', {
	    scope: $scope
  	}).then(function(modal) {
    	$scope.highVolumeModal = modal;
  	});
	$scope.openHighVolume = function(){
		$scope.highVolumeModal.show();
	}
	$scope.closeHighVolume = function(){
		$scope.highVolumeModal.hide();
	}
  $scope.nextView = function(){
     $state.go('tab.web');
     productDetailsDataFctr.setNextViewCountForBack();

 }

 $scope.previousView = function(){
   $state.go('tab.pic-sound');
   productDetailsDataFctr.setPreviousViewCountForBack();
 }

	function orderingDutyRate() {
                    var def = $q.defer();
                    var url = $f.serviceUrl + "/product/getdutyrates";
                    var req = {
                        method: 'get',
                        url: url
                    };
                    errorFctr.specificallyHandled(function () {
                        return $http(req)
                            .then(function (data) {
                                def.resolve(data.data);
                                $scope.orderingDutyRateDatas=data.data;
                               var dutyrateid = productDetailsDataFctr.getProductDetails().Ordering.DutyRateID;
                                 var isObject = _.where($scope.orderingDutyRateDatas, {ID: dutyrateid})
                                  if(isObject.length > 0)
                                    $scope.filterorderingDutyRateDatas =  isObject.Code;
                                  else
                                    $scope.filterorderingDutyRateDatas =  $scope.orderingDutyRateDatas[0].Code;
                              }, function (error) {
                                def.reject(error);
                            });
                    });

                    return def.promise;
            }

        orderingDutyRate();
         $scope.OrderingDutyRate = function(value){
             productDetailsDataFctr.getProductDetails().Ordering.DutyRateID = value.ID
         }
        $scope.ordering = {
          high_isChecked:false,
          medium_isChecked:false,
          low_isChecked:false
        }
        $scope.productdetails= productDetailsDataFctr.getProductDetails();
        $scope.searchproductcode = productDetailsDataFctr.getProductNameAndCode();
}]);
