angular.module('aralco.productsDetails.controllers')
.controller('PicSoundCtrl', ['productDetailsDataFctr','$scope', '$state', '$ionicSideMenuDelegate', '$ionicLoading', '$filter', '$ionicPopover', '$ionicModal','$cordovaCamera',
        function (productDetailsDataFctr,$scope, $state, $ionicSideMenuDelegate, $ionicLoading, $filter, $ionicPopover, $ionicModal,$cordovaCamera) {
	$ionicModal.fromTemplateUrl('modules/product_details/templates/picture-by-dimension-modal.html', {
	    scope: $scope
  	}).then(function(modal) {
    	$scope.pictureByDimensionModal = modal;
  	});
	$scope.openPictureByDimension = function(){
		$scope.pictureByDimensionModal.show();
	}
	$scope.closePictureByDimension = function(){
		$scope.pictureByDimensionModal.hide();
	}


  $ionicModal.fromTemplateUrl('modules/product_details/templates/audiorecording-modal.html', {
      scope: $scope
  }).then(function(modal) {
      $scope.openAudioRecording = modal;
  });

  var path = "";
  $scope.selectAudioView = function(){
      //$scope.openAudioRecording.show();
                             // capture callback
 var captureSuccess = function(mediaFiles) {
 var i,len;
 for (i = 0, len = mediaFiles.length; i < len; i += 1) {
 productDetailsDataFctr.getProductDetails().SoundFile = path = mediaFiles[i].fullPath;
 // do something interesting with the file
 }
 };

 // capture error callback
 var captureError = function(error) {
 navigator.notification.alert('Error code: ' + error.code, null, 'Capture Error');
 };

 // start audio capture
 navigator.device.capture.captureAudio(captureSuccess, captureError, {limit:1});
  }

 $scope.playAudio = function(){
 // Play the audio file at url
 var my_media = new Media(productDetailsDataFctr.getProductDetails().SoundFile,
                          // success callback
                          function () { console.log("playAudio():Audio Success"); },
                          // error callback
                          function (err) { console.log("playAudio():Audio Error: " + err); }
                          );

 // Play audio
 my_media.play();

 // Pause after 10 seconds
 setTimeout(function () {
            my_media.pause();
            }, 10000);


 }

  $scope.closeLookUp = function(){
      $scope.openAudioRecording.hide();
      //$scope.selectSupplierList = productDetailsDataFctr.getProductDetails().Suppliers;
  }



	$scope.takePicture = function(){
		var options = {
            targetWidth: 300,
            targetHeight: 300,
            quality: 70,
            allowEdit: false,
            encodingType: Camera.EncodingType.JPEG,
            mediaType: Camera.MediaType.PICTURE,
            //quality: 50,
            popoverOptions: CameraPopoverOptions,
            correctOrientation: true,
            saveToPhotoAlbum: true,
            destinationType: Camera.DestinationType.FILE_URL,
            sourceType: Camera.PictureSourceType.CAMERA
        };
        $cordovaCamera.getPicture(options).then(
            function(imageData) {
                $scope.picImage = imageData;
                productDetailsDataFctr.getProductDetails().images.value = $scope.picImage;
            },
            function(err) {
                //$ionicLoading.show({template: '', duration:500});
        })
	}
	$scope.selectPicture = function(){
		var options = {
            targetWidth: 300,
            targetHeight: 300,
            quality: 70,
            allowEdit: true,
            encodingType: Camera.EncodingType.JPEG,
            mediaType: Camera.MediaType.PICTURE,
            //quality: 50,
            popoverOptions: CameraPopoverOptions,
            correctOrientation: true,
            saveToPhotoAlbum: true,
            destinationType: Camera.DestinationType.FILE_URI,
            sourceType: Camera.PictureSourceType.PHOTOLIBRARY
        };

        $cordovaCamera.getPicture(options).then(
            function(imageURI) {
                $scope.picImage = imageURI;
                productDetailsDataFctr.getProductDetails().images.value = $scope.picImage;
            },
            function(err) {
                //$ionicLoading.show({template: '', duration:500});
        })
	}
   if(productDetailsDataFctr.getProductDetails().images!=null)
      $scope.picImage = productDetailsDataFctr.getProductDetails().images.value;

   $scope.dimension1grid = productDetailsDataFctr.getProductDetails().Matrix.Dimension1;
   if($scope.dimension1grid!=null)
       $scope.filterdimension1grid = productDetailsDataFctr.getProductDetails().Matrix.Dimension1.Grids[0].Value;

  $scope.dimension2grid = productDetailsDataFctr.getProductDetails().Matrix.Dimension2;
    if($scope.dimension2grid!=null)
       $scope.filterdimension2grid = productDetailsDataFctr.getProductDetails().Matrix.Dimension2.Grids[0].Value;

  $scope.dimension3grid = productDetailsDataFctr.getProductDetails().Matrix.Dimension3;
    if($scope.dimension3grid!=null)
      $scope.filterdimension3grid = productDetailsDataFctr.getProductDetails().Matrix.Dimension3.Grids[0].Value;

  $scope.dimension4grid = productDetailsDataFctr.getProductDetails().Matrix.Dimension4;
  if($scope.dimension4grid!=null)
      $scope.filterdimension4grid = productDetailsDataFctr.getProductDetails().Matrix.Dimension4.Grids[0].Value;

    $scope.nextView = function(){
       $state.go('tab.ordering');
       productDetailsDataFctr.setNextViewCountForBack();
   }

   $scope.previousView = function(){
     $state.go('tab.desc-pos');
     productDetailsDataFctr.setPreviousViewCountForBack();
   }
   $scope.searchproductcode = productDetailsDataFctr.getProductNameAndCode();
}]);
