angular.module('aralco.productsDetails.controllers')
.controller('ProdDetailsPricingCtrl', [ 'productDetailsDataFctr','$http','$q','$scope', '$state','errorFctr', '$ionicSideMenuDelegate', '$ionicLoading', '$filter',  'popupFctr','$ionicModal',
              function (productDetailsDataFctr,$http,$q, $scope, $state, errorFctr,$ionicSideMenuDelegate, $ionicLoading, $filter, popupFctr,$ionicModal) {

                var isNewProduct = productDetailsDataFctr.getProductDetails().Department.ID == undefined ? true : false;

                console.log("Current Item is a New Product: " + isNewProduct);

                if(!isNewProduct)
                {
                    var ele = document.getElementById('averageCost');
                    ele.setAttribute('disabled',true);

                    $scope.averagecost = productDetailsDataFctr.getProductDetails().AverageCost;

                }


                console.log(productDetailsDataFctr.getProductDetails().Suppliers);

                var supplierMultiplyFactor = 0;

          // Pricing Controller
          function pricingGetZone() {
                              var def = $q.defer();
                              var url = $f.serviceUrl + "/zone/get";
                              var req = {
                                  method: 'get',
                                  url: url
                              };
                              errorFctr.specificallyHandled(function () {
                                  return $http(req)
                                      .then(function (data) {
                                          def.resolve(data.data);
                                          $scope.pricingGetZoneDatas=data.data;
                                          $scope.filterpricingGetZoneDatas =  $scope.pricingGetZoneDatas[0].Name;
                                          }, function (error) {
                                          def.reject(error);
                                      });
                              });

                              return def.promise;
                }
                function pricingGetCustomerGroups() {
                              var def = $q.defer();
                              var url = $f.serviceUrl + "/customer/GetGroups";
                              var req = {
                                  method: 'get',
                                  url: url
                              };
                              errorFctr.specificallyHandled(function () {
                                  return $http(req)
                                      .then(function (data) {
                                      //debugger;
                                          def.resolve(data.data);
                                          $scope.pricingGetCustomerGroupsDatas=data.data;

                                      }, function (error) {
                                          def.reject(error);
                                      });
                              });

                              return def.promise;
                }
                function pricingGetPromotions() {
                    var def = $q.defer();
                    var url = $f.serviceUrl + "/product/GetPromotions";
                    var req = {
                        method: 'get',
                        url: url
                    };
                    errorFctr.specificallyHandled(function () {
                        return $http(req)
                            .then(function (data) {
                                def.resolve(data.data);
                                $scope.pricingGetPromotionsDatas=data.data;
                                for(i=0;i<$scope.pricingGetPromotionsDatas.length;i++){
                                   $scope.pricingGetPromotionsDatas[i].StartDate = new Date($scope.pricingGetPromotionsDatas[i].StartDate);
                                   $scope.pricingGetPromotionsDatas[i].EndDate = new Date($scope.pricingGetPromotionsDatas[i].EndDate);
                                 }
                            }, function (error) {
                                def.reject(error);
                            });
                    });

                    return def.promise;
      }
                pricingGetZone();
                pricingGetCustomerGroups();
                pricingGetPromotions();

                var supplierData=[];

                $scope.averagecost =  productDetailsDataFctr.getProductDetails().Pricing.AverageCost;
                $scope.standardcost =  productDetailsDataFctr.getProductDetails().Pricing.StandardCost;
                $scope.recentbasecost =  productDetailsDataFctr.getProductDetails().Pricing.RecentBaseCost;
                $scope.recentlandedcost =  productDetailsDataFctr.getProductDetails().Pricing.RecentLandedCost;
                $scope.msrp_price =  productDetailsDataFctr.getProductDetails().MSRP;
                $scope.msrp_gp_parsent = (($scope.msrp_price - $scope.averagecost)/$scope.msrp_price)*100;
                $scope.maximumdiscountperc = 0;
                $scope.zoneprice = 0;
                $scope.selectZoneID = 0;
                $scope.priceselectzonetype = function(result){
                  //  $scope.selectZoneID = result.ID;
                  //  var productZone = productDetailsDataFctr.getProductDetails().Pricing.Price;
                  //     var zone = _.where(productZone, {ZoneID:result.ID})
                  //     if(zone.length> 0)
                  //    {
                  //      $scope.zonecurrentprice =  zone[0].CurrentPrice;
                  //      $scope.zonepreviousprice = zone[0].PreviousPrice;
                  //      $scope.zoneretailprice =   zone[0].RetailPrice;
                  //      $scope.zonecompareprice =  zone[0].ComparePrice;
                  //    }
                    $scope.showPrices($scope.msrp_price,$scope.msrp_gp_parsent);
                }

        $scope.showPrices = function(price,parsent ){
        $scope.zoneprice =  $scope.zonecurrentprice =  $scope.zonepreviousprice =  price;
        $scope.zoneretailprice =  $scope.zonecompareprice = price;
        $scope.zonepriceparsent =  $scope.zonecurrentpriceparsent =  $scope.zonepreviouspriceparsent = parsent;
        $scope.zoneretailpriceparsent =  $scope.zonecomparepriceparsent = parsent ;
       }


                    console.log($scope.pricingGetCustomerGroupsDatas);
                function setAvgCost()
                {
                  //debugger;
                    if(isNewProduct)
                    {
                        $scope.averagecost = $scope.recentlandedcost;
                    }
                }

                $scope.updateValues = function(option,values){
                        values = parseInt(values,10);
                        values = isNaN(values) ? 0 : values;

                   switch (option) {
                         case "msrp_gp_parsent":
                         if($scope.selectsuppliertype!=null && $scope.selectsuppliertype != "undefined"){
                           $scope.msrp_gp_parsent = values;
                           $scope.msrp_gp_parsent = (($scope.msrp_price - $scope.averagecost)/$scope.msrp_price)*100;
                           $scope.recentlandedcost = ($scope.recentbasecost /supplierData[0].BaseLanded);
                           $scope.msrp_price = supplierData[0].LandedRetail *  $scope.recentlandedcost;

                           $scope.averagecost = $scope.standardcost = $scope.recentlandedcost;
                           productDetailsDataFctr.getProductDetails().Pricing.RecentLandedCost = $scope.recentlandedcost;

                           if(isNewProduct){
                             productDetailsDataFctr.getProductDetails().MSRP = $scope.msrp_price;
                           }
                          }
                         break;
                         case "averagecost":
                            $scope.averagecost = values;
                            productDetailsDataFctr.getProductDetails().Pricing.AverageCost = values ;

                            //$scope.msrp_gp_parsent = (($scope.msrp_price - values)/$scope.msrp_price)*100;
                         break;
                         case "standardcost":
                            productDetailsDataFctr.getProductDetails().Pricing.StandardCost = values;
                            break;
                          case "recentbasecost":
                             productDetailsDataFctr.getProductDetails().Pricing.RecentBaseCost = values;
                             $scope.recentbasecost = values;
                             if($scope.selectsuppliertype!=null && $scope.selectsuppliertype != "undefined")
                              $scope.selectSupplierTypeValue($scope.selectsuppliertype);
                         break;
                         case "recentlandedcost":
                            if($scope.selectsuppliertype!=null && $scope.selectsuppliertype != "undefined"){
                              // $scope.supplierMultiplyFactor = supplierData[0].BaseLanded;
                              // $scope.recentbasecost = ($scope.recentlandedcost/$scope.supplierMultiplyFactor);
                              // $scope.averagecost = $scope.standardcost = $scope.recentlandedcost;
                              $scope.recentlandedcost = values;
                              productDetailsDataFctr.getProductDetails().Pricing.RecentLandedCost = $scope.recentlandedcost;
                              $scope.msrp_price = supplierData[0].LandedRetail *  $scope.recentlandedcost;
                              $scope.msrp_gp_parsent = (($scope.msrp_price - $scope.averagecost)/$scope.msrp_price)*100;
                              if(isNewProduct){
                                productDetailsDataFctr.getProductDetails().MSRP = $scope.msrp_price;
                              }
                             }
                            break
                         case "msrp_price":
                          if($scope.averagecost == undefined || $scope.averagecost == null){
                            popupFctr.alert('Oops!','Average Cost for this product is not set');
                            document.getElementById('msrp').value = productDetailsDataFctr.getProductDetails().MSRP;
                            console.log($scope.msrp_price);
                            break;
                          }``
                           if($scope.selectsuppliertype!=null && $scope.selectsuppliertype != "undefined"){
                              $scope.msrp_price =values;
                              // $scope.supplierMultiplyFactor = supplierData[0].BaseLanded;
                              // $scope.recentlandedcost = ($scope.msrp_price/supplierData[0].LandedRetail) ;
                              // $scope.recentbasecost = ($scope.recentlandedcost/$scope.supplierMultiplyFactor);
                              // productDetailsDataFctr.getProductDetails().Pricing.RecentLandedCost = $scope.recentlandedcost;
                              // $scope.averagecost = $scope.standardcost = $scope.recentlandedcost;
                              $scope.msrp_gp_parsent = (($scope.msrp_price - $scope.recentlandedcost)/$scope.msrp_price)*100;
                              if(isNewProduct){
                                productDetailsDataFctr.getProductDetails().MSRP = $scope.msrp_price;
                              }
                             }
                        break;
                        case "zoneprice":
                              var productZone = productDetailsDataFctr.getProductDetails().Pricing.Price;
                              var zone = _.where(productZone, {ZoneID:values.ID})
                              if( zone.length > 0){
                                 productDetailsDataFctr.getProductDetails().Pricing.Price = removeItems(values.ID);
                                 var zoneObject  = zone[0];
                                 zoneObject.CurrentPrice = $scope.zonecurrentprice ;
                                 zoneObject.PreviousPrice = $scope.zonepreviousprice;
                                 zoneObject.RetailPrice = $scope.zoneretailprice ;
                                 zoneObject.ComparePrice = $scope.zonecompareprice ;
                                 productDetailsDataFctr.getProductDetails().Pricing.Price.push(zoneObject);
                                }
                               else{
                               var zoneObject = {};
                               zoneObject.CurrentPrice = $scope.zonecurrentprice ;
                               zoneObject.PreviousPrice = $scope.zonepreviousprice;
                               zoneObject.RetailPrice = $scope.zoneretailprice ;
                               zoneObject.ComparePrice = $scope.zonecompareprice ;
                               productDetailsDataFctr.getProductDetails().Pricing.Price.push(zone);
                             }
                        break;
                     default:
                   }
                }
                var removeItems = function (id) {
                              return productDetailsDataFctr.getProductDetails().Pricing.Price.filter(function( obj ) {
                                return obj.ZoneID !== id;
                              });
                 };
            function init() {
               //debugger;
                 $scope.selectSupplierList =  productDetailsDataFctr.getProductDetails().Suppliers;
                     if($scope.selectSupplierList!=null && $scope.selectSupplierList.length > 0)
                      for(supplierObject in  $scope.selectSupplierList){
                         if($scope.selectSupplierList[supplierObject].isCheck){
                           $scope.selectsuppliertype = $scope.selectSupplierList[supplierObject];
                           }
                       }
            }


            $scope.selectSupplierTypeValue = function(value)
            {
                //debugger;
                if (typeof value === 'string' || value instanceof String)
                value = JSON.parse(value);
                $scope.selectsuppliertype = value;
                getSupplierRateMultiplier(value.Id).then(function()
                {
                     //debugger;
                    console.log(supplierData);
                    $scope.supplierMultiplyFactor = supplierData[0].BaseLanded;
                    console.log($scope.supplierMultiplyFactor);
                    console.log("RBC: " + $scope.recentbasecost);
                    $scope.recentlandedcost = ($scope.recentbasecost * $scope.supplierMultiplyFactor );
                    $scope.averagecost = $scope.standardcost = $scope.recentlandedcost;
                    console.log($scope.recentlandedcost);
                    setAvgCost();
                    console.log(supplierData[0].LandedRetail);
                    $scope.msrp_price = supplierData[0].LandedRetail *  $scope.recentlandedcost;
                    $scope.msrp_gp_parsent = (($scope.msrp_price - $scope.recentlandedcost)/$scope.msrp_price)*100;
                    console.log(productDetailsDataFctr.getProductDetails().MSRP);
                    if(isNewProduct){
                      productDetailsDataFctr.getProductDetails().MSRP = $scope.msrp_price;
                    }
                },function(){

                }
            );
                console.log(supplierMultiplyFactor + " " + $scope.recentbasecost);
            }
             init();
             $scope.nextView = function(){
                $state.go('tab.properties');
                     productDetailsDataFctr.setNextViewCountForBack();
           }

           function getSupplierRateMultiplier(id)
           {
            //debugger;
            var def = $q.defer();
            var url = $f.serviceUrl + "supplier/get/" + id;
            var req = {
                method: 'get',
                url: url
            };
            errorFctr.specificallyHandled(function () {
                return $http(req)
                    .then(function (data) {
                        def.resolve(data.data);
                        console.log(data.data);

                        supplierData =data.data;
                    }, function (error) {
                        def.reject(error);
                    });
            });

            return def.promise;
           }

           $scope.previousView = function(){
              $state.go('tab.supplier');
              productDetailsDataFctr.setPreviousViewCountForBack()
         }
        $scope.searchproductcode = productDetailsDataFctr.getProductNameAndCode();
}]);
