angular.module('aralco.productsDetails.controllers')
.controller('ProdDetailsTaxCtrl', ['productDetailsDataFctr', '$http','$q','$scope', '$state','errorFctr', '$ionicSideMenuDelegate', '$ionicLoading', '$filter', '$ionicModal',
    function (productDetailsDataFctr, $http,$q, $scope, $state, errorFctr,$ionicSideMenuDelegate, $ionicLoading, $filter, $ionicModal) {
            function executeTax() {
                    var def = $q.defer();
                    var url = $f.serviceUrl + "/tax/getall";
                    var req = {
                        method: 'get',
                        url: url
                    };
                    errorFctr.specificallyHandled(function () {
                        return $http(req)
                            .then(function (data) {
                                def.resolve(data.data);
                                $scope.taxItems= [];


                                var productlist = productDetailsDataFctr.getProductDetails();
                                data.data.forEach(function(item){
                                      if(productlist!=null && productlist.Taxes!=null && productlist.Taxes.length > 0){
                                        if(_.where(productlist.Taxes, {ID: item.ID}).length > 0 )
                                              $scope.taxItems.push({data:item,isChecked:true});
                                         else
                                              $scope.taxItems.push({data:item,isChecked:false});
                                      }
                                      else {
                                           $scope.taxItems.push({data:item,isChecked:false});
                                         }
                                });
                             }, function (error) {
                                def.reject(error);
                            });
                    });
                    return def.promise;
            }
            $scope.taxItems = null;
            $scope.taxItems = [];
            $scope.gstqtyText = productDetailsDataFctr.getProductDetails().GSTQuantity;
            $scope.taxSelectItems =  function(taxItem){
                    if(taxItem.isChecked)
                        productDetailsDataFctr.getProductDetails().Taxes.push(taxItem.data);
                    else
                       productDetailsDataFctr.getProductDetails().Taxes = removeItems(taxItem.data);
            }
           var removeItems = function (values) {
                         return productDetailsDataFctr.getProductDetails().Taxes.filter(function( obj ) {
                           return obj.ID !== values.ID;
                         });
            };
        $scope.enterGstQty = function(value){
          productDetailsDataFctr.getProductDetails().GSTQuantity = value;
        }
          $scope.nextView = function(){
             $state.go('tab.units');
             productDetailsDataFctr.setNextViewCountForBack();
         }
        $scope.searchproductcode = productDetailsDataFctr.getProductNameAndCode();
        executeTax();
  }]);
