﻿(function () {
    "use strict";
    var module = angular.module('aralco.sql', ['ionic', 'ngCordova']);

    module.run(function ($ionicPlatform, $cordovaSQLite, popupFctr) {
        $ionicPlatform.ready(function () {
            window.db = null;
            if (window.cordova) {
                //db = $cordovaSQLite.openDB("aralco.mobile");
                db = $cordovaSQLite.openDB({name: "aralco.mobile", iosDatabaseLocation: 'default'});
            } else if (window.openDatabase){
                db = window.openDatabase("aralco.mobile", "1.0", "Aralco Mobile", 1000000);
            } else {
                var message = "The module Offline SQL is not supported on your current browser. Most features will " +
                    "not work! Please switch to Safari, Google Chrome, or the mobile app version.";
                popupFctr.alert('There was an error...', message);
            }

        });
    })

})();