(function () {
    
	var module = angular.module('aralco.taxtables',['ionic']);
	
	module.factory('taxTableFactory', function($filter) {

        var elementId = 19;

		var taxTables = [
			{
                ID: 1,
                name: "BTL DEP",
                desc: "BTL DEP",
                type: "",
                defaultTax: "",
                stampProducts: "",
                inclInPrice: "",
                value: 0,
                currency: "percentage",
                taxChangeDate: "",
                taxNameBefore: "",
                percentBefore: 0,
                federalTaxForEcommerce: "",
                outOfProvinceTax: "",
                provState: ""
            },
            {
                ID: 2,
                name: "COTax4.63",
                desc: "COTax4.63",
                type: "",
                defaultTax: "",
                stampProducts: "",
                inclInPrice: "",
                value: 0,
                currency: "percentage",
                taxChangeDate: "",
                taxNameBefore: "",
                percentBefore: 0,
                federalTaxForEcommerce: "",
                outOfProvinceTax: "",
                provState: ""
            },
            {
                ID: 3,
                name: "Excise Tax",
                desc: "Excise Tax",
                type: "",
                defaultTax: "",
                stampProducts: "",
                inclInPrice: "",
                value: 0,
                currency: "percentage",
                taxChangeDate: "",
                taxNameBefore: "",
                percentBefore: 0,
                federalTaxForEcommerce: "",
                outOfProvinceTax: "",
                provState: ""
            },
            {
                ID: 4,
                name: "GST",
                desc: "GST",
                type: "",
                defaultTax: "",
                stampProducts: "",
                inclInPrice: "",
                value: 0,
                currency: "percentage",
                taxChangeDate: "",
                taxNameBefore: "",
                percentBefore: 0,
                federalTaxForEcommerce: "",
                outOfProvinceTax: "",
                provState: ""
            },
            {
                ID: 5,
                name: "HST",
                desc: "HST",
                type: "",
                defaultTax: "",
                stampProducts: "",
                inclInPrice: "",
                value: 0,
                currency: "percentage",
                taxChangeDate: "",
                taxNameBefore: "",
                percentBefore: 0,
                federalTaxForEcommerce: "",
                outOfProvinceTax: "",
                provState: ""
            },
            {
                ID: 6,
                name: "HST inc",
                desc: "HST inc",
                type: "",
                defaultTax: "",
                stampProducts: "",
                inclInPrice: "",
                value: 0,
                currency: "percentage",
                taxChangeDate: "",
                taxNameBefore: "",
                percentBefore: 0,
                federalTaxForEcommerce: "",
                outOfProvinceTax: "",
                provState: ""
            },
            {
                ID: 7,
                name: "Levy",
                desc: "Levy",
                type: "",
                defaultTax: "",
                stampProducts: "",
                inclInPrice: "",
                value: 0,
                currency: "percentage",
                taxChangeDate: "",
                taxNameBefore: "",
                percentBefore: 0,
                federalTaxForEcommerce: "",
                outOfProvinceTax: "",
                provState: ""
            },
            {
                ID: 8,
                name: "Liquor",
                desc: "Liquor",
                type: "",
                defaultTax: "",
                stampProducts: "",
                inclInPrice: "",
                value: 0,
                currency: "percentage",
                taxChangeDate: "",
                taxNameBefore: "",
                percentBefore: 0,
                federalTaxForEcommerce: "",
                outOfProvinceTax: "",
                provState: ""
            },
            {
                ID: 9,
                name: "New York",
                desc: "New York",
                type: "",
                defaultTax: "",
                stampProducts: "",
                inclInPrice: "",
                value: 0,
                currency: "percentage",
                taxChangeDate: "",
                taxNameBefore: "",
                percentBefore: 0,
                federalTaxForEcommerce: "",
                outOfProvinceTax: "",
                provState: ""
            },
            {
                ID: 10,
                name: "ONT HST",
                desc: "ONT HST",
                type: "",
                defaultTax: "",
                stampProducts: "",
                inclInPrice: "",
                value: 0,
                currency: "percentage",
                taxChangeDate: "",
                taxNameBefore: "",
                percentBefore: 0,
                federalTaxForEcommerce: "",
                outOfProvinceTax: "",
                provState: ""
            },
            {
                ID: 11,
                name: "PST - BC",
                desc: "PST - BC",
                type: "",
                defaultTax: "",
                stampProducts: "",
                inclInPrice: "",
                value: 0,
                currency: "percentage",
                taxChangeDate: "",
                taxNameBefore: "",
                percentBefore: 0,
                federalTaxForEcommerce: "",
                outOfProvinceTax: "",
                provState: ""
            },
            {
                ID: 12,
                name: "PST - ON",
                desc: "PST - ON",
                type: "",
                defaultTax: "",
                stampProducts: "",
                inclInPrice: "",
                value: 0,
                currency: "percentage",
                taxChangeDate: "",
                taxNameBefore: "",
                percentBefore: 0,
                federalTaxForEcommerce: "",
                outOfProvinceTax: "",
                provState: ""
            },
            {
                ID: 13,
                name: "PST - SK",
                desc: "PST - SK",
                type: "",
                defaultTax: "",
                stampProducts: "",
                inclInPrice: "",
                value: 0,
                currency: "percentage",
                taxChangeDate: "",
                taxNameBefore: "",
                percentBefore: 0,
                federalTaxForEcommerce: "",
                outOfProvinceTax: "",
                provState: ""
            },
            {
                ID: 14,
                name: "QST",
                desc: "QST",
                type: "",
                defaultTax: "",
                stampProducts: "",
                inclInPrice: "",
                value: 0,
                currency: "percentage",
                taxChangeDate: "",
                taxNameBefore: "",
                percentBefore: 0,
                federalTaxForEcommerce: "",
                outOfProvinceTax: "",
                provState: ""
            },
            {
                ID: 15,
                name: "RST - MB",
                desc: "RST - MB",
                type: "",
                defaultTax: "",
                stampProducts: "",
                inclInPrice: "",
                value: 0,
                currency: "percentage",
                taxChangeDate: "",
                taxNameBefore: "",
                percentBefore: 0,
                federalTaxForEcommerce: "",
                outOfProvinceTax: "",
                provState: ""
            },
            {
                ID: 16,
                name: "tax 5%",
                desc: "tax 5%",
                type: "",
                defaultTax: "",
                stampProducts: "",
                inclInPrice: "",
                value: 0,
                currency: "percentage",
                taxChangeDate: "",
                taxNameBefore: "",
                percentBefore: 0,
                federalTaxForEcommerce: "",
                outOfProvinceTax: "",
                provState: ""
            },
            {
                ID: 17,
                name: "Texas",
                desc: "Texas",
                type: "",
                defaultTax: "",
                stampProducts: "",
                inclInPrice: "",
                value: 0,
                currency: "percentage",
                taxChangeDate: "",
                taxNameBefore: "",
                percentBefore: 0,
                federalTaxForEcommerce: "",
                outOfProvinceTax: "",
                provState: ""
            },
            {
                ID: 18,
                name: "VAT Incl (12%)",
                desc: "VAT Incl (12%)",
                type: "",
                defaultTax: "",
                stampProducts: "",
                inclInPrice: "",
                value: 0,
                currency: "percentage",
                taxChangeDate: "",
                taxNameBefore: "",
                percentBefore: 0,
                federalTaxForEcommerce: "",
                outOfProvinceTax: "",
                provState: ""
            }            
		];

		return {
			getTaxTables : function(searchText) {
                return $filter('filter')(taxTables, {name: searchText})
			},
			addTaxTable : function(taxTable) {
				var temp = {
                    ID: elementId++,                    
					name: taxTable.name,
                    desc: taxTable.desc,
                    type: taxTable.type,
                    defaultTax: taxTable.defaultTax,
                    stampProducts: taxTable.stampProducts,
                    inclInPrice: taxTable.inclInPrice,
                    value: taxTable.value,
                    currency: taxTable.currency,
                    taxChangeDate: taxTable.taxChangeDate,
                    taxNameBefore: taxTable.taxNameBefore,
                    percentBefore: taxTable.percentBefore,
                    federalTaxForEcommerce: taxTable.federalTaxForEcommerce,
                    outOfProvinceTax: taxTable.outOfProvinceTax,
                    provState: taxTable.provState
				}

				taxTables.push(temp);
			},
			deleteTaxTable: function(item) {
                var index = taxTables.findIndex(taxTable => taxTable.ID == item.ID);
                taxTables.splice(index, 1);
            },
			 saveTaxTable: function(item,taxTable) {
                var index = taxTables.findIndex(taxTable => taxTable.ID == item.ID);
				taxTables[index].name = taxTable.name;
                taxTables[index].desc = taxTable.desc;
                taxTables[index].type = taxTable.type;
                taxTables[index].defaultTax = taxTable.defaultTax;
                taxTables[index].stampProducts = taxTable.stampProducts;
                taxTables[index].inclInPrice = taxTable.inclInPrice;
                taxTables[index].value = taxTable.value;
                taxTables[index].currency = taxTable.currency;
                taxTables[index].taxChangeDate = taxTable.taxChangeDate;
                taxTables[index].taxNameBefore = taxTable.taxNameBefore;
                taxTables[index].percentBefore = (taxTable.percentBefore != undefined? taxTable.percentBefore: 0);
                taxTables[index].federalTaxForEcommerce = taxTable.federalTaxForEcommerce;
                taxTables[index].outOfProvinceTax = taxTable.outOfProvinceTax;
                taxTables[index].provState = taxTable.provState;
			},
			getTaxTableByIndex : function(item) {
                return taxTables.filter(taxTable => taxTable.ID == item.ID)[0];
            }
		};
    });
    
    module.directive('selectOnClick', ['$window', function ($window) {
        if(ionic.Platform.isIOS()) {
            return {
                restrict: 'A',
                link: function (scope, element, attrs) {
                    element.on('click', function () {
                        if (!$window.getSelection().toString()) {
                            this.setSelectionRange(0, this.value.length)
                        }
                    });
                }
            };
        }
        else {
            return {
                restrict: 'A',
                link: function (scope, element) {
                    var focusedElement;
                    element.on('click', function () {
                        this.select();
                        focusedElement = this;
                    });
                    element.on('blur', function () {
                        focusedElement = null;
                    });
                }
            };
        }
    }]);
	
	module.config(['$stateProvider', '$provide', '$urlRouterProvider',
	'$httpProvider', function ($stateProvider, $provide, $urlRouterProvider, $httpProvider) {
		$stateProvider
		.state('tab.taxtables', {
			url: '/taxtables',
			LoginRequired: true,
			views: {
				'tab-view': {
					templateUrl: 'modules/common_html/templates/view.html',
					controller: 'TaxTableController'
				}
			}
		})
		.state('tab.edittaxtables', {
			url: '/edittaxtable/:name',
            LoginRequired: true,
            views: {
				'tab-view': {
					templateUrl: 'modules/tax_tables/templates/tax-tables-edit.html',
                    controller: 'EditTaxTableController'
				}
			}
		})
		.state('tab.addtaxtables', {
			url: '/edittaxtable/:name',
            LoginRequired: true,
            views: {
				'tab-view': {
					templateUrl: 'modules/tax_tables/templates/tax-tables-edit.html',
                    controller: 'AddTaxTableController'
				}
			}	
		})
	}]);

    module.controller('TaxTableController', function($scope,$state,$ionicPopup,$filter,$rootScope,$ionicScrollDelegate,taxTableFactory){
        $scope.selectedItem = null;
        $scope.itemSelected = false;
        $scope.title = "Manage Taxes";
        $scope.searchTitle = "Tax Tables"

        
       

        
            
            {
        }

        $scope.gotoAddEditPage = function(pagename){
            if(pagename == 'edit' && $scope.selectedItem != null){
                $state.go('tab.edittaxtables',{name: JSON.stringify($scope.selectedItem)});
            }
            if(pagename == 'add'){
                $state.go('tab.addtaxtables',{name: 'add'});
            } 
        }

        $scope.setSelectedItem = function(item) {
            $scope.selectedItem = item;
            $scope.itemSelected = true;
        }

        $scope.clearSelectedItem = function() {
            $scope.selectedItem = null;
            $scope.itemSelected = false;
        }

        $scope.deleteItem = function() {
            if($scope.selectedItem != null) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Are you sure you want to delete?',
                    cancelText: 'No',
                    okText: 'Yes'
                }).then(function(val) {
                    if(val == true){
                        taxTableFactory.deleteTaxTable($scope.selectedItem);
                        $rootScope.$emit('updateTaxTables', {
                            editType: "Deleted"
                        });
                    }
                })
            }
        }

        $scope.searchItem = function() {
            $scope.entries = angular.copy(taxTableFactory.getTaxTables($scope.searchContent));
            $scope.showContent = true;
            $scope.clearSelectedItem();
            $scope.scrollMainToTop();
        }
        
        $rootScope.$on('updateTaxTables', function(event, arg) {
            $scope.entries = angular.copy(taxTableFactory.getTaxTables($scope.searchContent));
        });
        
        $scope.scrollMainToTop = function() {
             $ionicScrollDelegate.$getByHandle('mainScroll').scrollTop();
        };
    })

    module.controller('EditTaxTableController', function($scope,$state,$stateParams,$ionicPopup,$ionicHistory,$rootScope,taxTableFactory){
        $scope.selectedItem = angular.copy(JSON.parse($stateParams.name));
        $scope.taxTable = angular.copy(taxTableFactory.getTaxTableByIndex($scope.selectedItem));
        $scope.searchTitle = $scope.taxTable.name;
        $scope.title = "Edit Tax";

        
       

        
            
            {
        }

        $scope.autoFillDescription = function() {
            if($scope.taxTable.desc.length == 0) {
                $scope.taxTable.desc = $scope.taxTable.name;
            }
        }

        $scope.goBack = function() {
            if(!angular.equals($scope.taxTable, taxTableFactory.getTaxTableByIndex($scope.selectedItem))) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        var errorCheck = document.getElementsByClassName('error-message');
                        var validity = true;
                        for(var i = 0; i < errorCheck.length; i++) {
                            if(errorCheck[i].classList.length == 1 && errorCheck[i].classList[0] == "error-message") {
                                validity = false;
                            }
                        }
            
                        if(validity) {
                            taxTableFactory.saveTaxTable($scope.selectedItem,$scope.taxTable);
                            $rootScope.$emit('updateTaxTables', {
                                editType: "Saved"
                            });
                            var popupMessage = $ionicPopup.alert( {
                                title: 'Record saved successfully.',
                                subTitle: ''
                            })
                            $ionicHistory.goBack();
                        } else {
                            var popupMessage = $ionicPopup.alert( {
                                title: 'Invalid Input.',
                                subTitle: ''
                            })
                        } 
                    } else {
                        $ionicHistory.goBack();
                    }
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }
        
        $scope.saveTaxTable = function() {
            var errorCheck = document.getElementsByClassName('error-message');
            var validity = true;
            for(var i = 0; i < errorCheck.length; i++) {
                if(errorCheck[i].classList.length == 1 && errorCheck[i].classList[0] == "error-message") {
                    validity = false;
                }
            }

            if(validity) {
                taxTableFactory.saveTaxTable($scope.selectedItem,$scope.taxTable);
                $rootScope.$emit('updateTaxTables', {
                    editType: "Saved"
                });
                var popupMessage = $ionicPopup.alert( {
                    title: 'Record saved successfully.',
                    subTitle: ''
                })
            } else {
                var popupMessage = $ionicPopup.alert( {
                    title: 'Invalid Input.',
                    subTitle: ''
                })
            }
        }

        $scope.clearTaxTable = function() {
            if(!angular.equals($scope.taxTable, taxTableFactory.getTaxTableByIndex($scope.selectedItem))) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        $scope.saveTaxTable(); 
                    }
                    else{
                        $scope.taxTable = angular.copy(taxTableFactory.getTaxTableByIndex($scope.selectedItem));
                    }
                })
            }
        }

        $scope.deleteTaxTable = function() {
            var popupMessage = $ionicPopup.confirm( {
                title: 'Are you sure you want to delete?',
                cancelText: 'No',
                okText: 'Yes'
            }).then(function(val) {
                if(val == true){
                    taxTableFactory.deleteTaxTable($scope.selectedItem);
                    $rootScope.$emit('updateTaxTables', {
                        editType: "Deleted"
                    });
                    $ionicHistory.goBack(); 
                }
            })
        }

        $scope.cancelEdit = function() {
            if(!angular.equals($scope.taxTable, taxTableFactory.getTaxTableByIndex($scope.selectedItem))) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Are you sure you want to cancel?',
                    cancelText: 'No',
                    okText: 'Yes'
                }).then(function(val) {
                    if(val == true){
                        $scope.taxTable = angular.copy(taxTableFactory.getTaxTableByIndex($scope.selectedItem));
                    }
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }
    })

    module.controller('AddTaxTableController', function($scope,$ionicPopup,$ionicHistory,$rootScope,taxTableFactory){
        $scope.showSearchbar = true;
        $scope.title = "Add Tax";
        $scope.taxTable = {
            name: "",
            desc: "",
            type: "",
            defaultTax: "",
            stampProducts: "",
            inclInPrice: "",
            value: 0,
            currency: "percentage",
            taxChangeDate: "",
            taxNameBefore: "",
            percentBefore: 0,
            federalTaxForEcommerce: "",
            outOfProvinceTax: "",
            provState: ""
        }
        var oriTaxTable = angular.copy($scope.taxTable);

        $scope.autoFillDescription = function() {
            if($scope.taxTable.desc.length == 0) {
                $scope.taxTable.desc = angular.copy($scope.taxTable.name);
            }
        }

        
       //var margintop = 75 + subtoppadding - 55;

        
            
            {
        }

        $scope.goBack = function() {
            if(!angular.equals($scope.taxTable, oriTaxTable)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        var errorCheck = document.getElementsByClassName('error-message');
                        var validity = true;
                        for(var i = 0; i < errorCheck.length; i++) {
                            if(errorCheck[i].classList.length == 1 && errorCheck[i].classList[0] == "error-message") {
                                validity = false;
                            }
                        }
            
                        if(validity) {
                            taxTableFactory.addTaxTable($scope.taxTable);
                            $rootScope.$emit('updateTaxTables', {
                                editType: "Added"
                            });
                            var popupMessage = $ionicPopup.alert( {
                                title: 'Record saved successfully.',
                                subTitle: ''
                            }).then(function() {
                                $scope.taxTable = angular.copy(oriTaxTable);
                            })
                            $ionicHistory.goBack();
                        } else {
                            var popupMessage = $ionicPopup.alert( {
                                title: 'Invalid Input.',
                                subTitle: ''
                            })
                        } 
                    } else {
                        $ionicHistory.goBack();
                    }
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }

        $scope.saveTaxTable = function() {
            if(!angular.equals($scope.taxTable, oriTaxTable)) {
                var errorCheck = document.getElementsByClassName('error-message');
                var validity = true;
                for(var i = 0; i < errorCheck.length; i++) {
                    if(errorCheck[i].classList.length == 1 && errorCheck[i].classList[0] == "error-message") {
                        validity = false;
                    }
                }
    
                if(validity) {
                    taxTableFactory.addTaxTable($scope.taxTable);
                    $rootScope.$emit('updateTaxTables', {
                        editType: "Added"
                    });
                    var popupMessage = $ionicPopup.alert( {
                        title: 'Record saved successfully.',
                        subTitle: ''
                    }).then(function() {
                        $scope.taxTable = angular.copy(oriTaxTable);
                    })
                } else {
                    var popupMessage = $ionicPopup.alert( {
                        title: 'Invalid Input.',
                        subTitle: ''
                    })
                }
            }
        }

        $scope.addTaxTable = function() {
            $scope.clearTaxTable();
        }

        $scope.clearTaxTable = function() {
            if(!angular.equals($scope.taxTable, oriTaxTable)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        $scope.saveTaxTable(); 
                    }
                    $scope.taxTable = angular.copy(oriTaxTable);
                })
            }
        }

        $scope.cancelEdit = function() {
            if(!angular.equals($scope.taxTable, oriTaxTable)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Are you sure you want to cancel?',
                    cancelText: 'No',
                    okText: 'Yes'
                }).then(function(val) {
                    if(val == true){
                        $scope.taxTable = angular.copy(oriTaxTable); 
                    }
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }
    })
})();