﻿/// <reference path="../../Scripts/underscore.js" />


function scan(source) {
    var self = this;

   // self.ScanID = null;
    self.barcode = null;
    self.product = null;
    self.location = null;
    scan.count = {};
    self.modifiedBy = null;
    self.modifiedOn = null;
    self.manuallyUpdated = false;
    self.SerialNumber = null;
    self.itemcode=null;
    //0=> Scan, 1=Manual
    self.type = null;
    self.parentReference = null;

    var init = function (obj) {
        /// <summary>
        /// Fill the object data from a json
        /// </summary>
        /// <returns type=""></returns>
        if (!_.isObject(obj))
            obj = JSON.parse(obj);

        if (obj != null) {
            //if there is no barcode, assuming is a product
            if (_.isUndefined(obj.barcode))
            {
                self.product = new product(obj);
            }
            self.itemcode = obj.Code;
            self.ScanID = obj.ScanID;
            self.barcode = obj.Barcode;
            self.location = obj.location;
            self.count = obj.count;
            self.modifiedBy = obj.modifiedBy;
            self.modifiedOn = obj.modifiedOn;
            self.manuallyUpdated = obj.manuallyUpdated;
            self.SerialNumber = obj.SerialNumber;
            self.parentReference = obj.parentReference;
        }

    };

    if (source != null)
        init(source);

    return self;
}
