﻿(function () {

    var module = angular.module('aralco.about',['ionic']);

    module.config(['$stateProvider', '$provide', '$urlRouterProvider',
    '$httpProvider', function ($stateProvider, $provide, $urlRouterProvider, $httpProvider) {

        $stateProvider

        .state('tab.about', {
            url: '/about',
            LoginRequired: true,
            views: {
                'tab-dash': {
                    templateUrl: 'modules/about/templates/tab-about.html',
                    controller: 'aboutCtr'
                }
            }
        });



    }]);
    module.constant('APP_ABOUT', {
        name: 'Aralco Mobile',
        legalterm:'Use of this software and the other materials contained in the software package (the \'Materials\')'
                    + 'has been provided under a Software Licence Agreement (please read  in  full).'
                    +'In summary,  ARALCO  grants you a non-transferrable personal licence (see licence details) '
                    + 'to use the  Materials only on a single or subsequent (but not additional) computer for the length of your licence (see licence details.)'
                    + 'You receive the right to use the Materials, but you do not become the owner of them.'
                    + 'You may not alter, decompile, or reverse- assemble the software, and YOU MAY NOT COPY the Materials.'
                    +'The Materials are protected by copyright, trade secrets, and trademark law, the violation of which may result in civil damages and criminal prosecution.',
        copyright:'Copyright © 1986 - ' + (new Date()).getFullYear() + ' Alan Raffie And Associates Ltd.'});

    module.controller("aboutCtr", ['$scope', 'deviceFctr','$filter','APP_ABOUT', function ($scope, deviceFctr,$filter,APP_ABOUT) {

        init();

        function init() {
            $scope.info = {};
            deviceFctr.$getDevice().then(function (result) {
                $scope.info.result;
                $scope.app = APP_ABOUT;
                   
            });
        }
    }])

    module.factory('deviceFctr', ['$q', '$ionicPlatform', function ($q, $ionicPlatform) {
        var self = this;
        self.$getDevice = function () {

            var deferred = $q.defer();
            $ionicPlatform.ready(function () {
                var result = ionic.Platform.device();
                deferred.resolve(result);
            });

            return deferred.promise;
        };
        return self;
    }])

})();