(function () {
    
	var module = angular.module('aralco.departments',['ionic']);
	
	module.factory('departmentFactory', function($filter) {

        var elementId = 20;

        var departmentList = [
            "Accessories",
            "Trailer",
            "Axles",
            "Active Shoes",
            "Additions",
            "Adhesive",
            "Admissions",
            "Adult",
            "Adult Activity",
            "Age 16+",
            "Age 35",
            "Age 6.15",
            "Agriculture",
            "Air",
            "Airbrush",
            "Alcohol",
            "Alied",
            "Amino Acids",
            "Ankle Support"            
        ];

        var groupList = [
            {
                name: "Action/Type",
                value: false
            },
            {
                name: "Admission",
                value: false
            },
            {
                name: "Age",
                value: false
            },
            {
                name: "Age Group",
                value: false
            },
            {
                name: "Aisle",
                value: false
            },
            {
                name: "Alberta",
                value: false
            },
            {
                name: "Alcohol Type",
                value: false
            },
            {
                name: "Animal",
                value: false
            },
            {
                name: "Amperage",
                value: false
            },
            {
                name: "Art Style",
                value: false
            },
            {
                name: "Art Type",
                value: false
            },
            {
                name: "Artwork",
                value: false
            },
            {
                name: "Aspect Ratio",
                value: false
            }
        ];

		var departments = [
			{
                ID: 1,
                name: "Accessories",
                desc: "Accessories",
                eCommerce: "",
                deactivate: "",
                suppressPrinting: "",
                parentDepartment: "",
                scaleDepartmentId: 0,
                groups: angular.copy(groupList)
            },
            {
                ID: 2,
                name: "Trailer",
                desc: "Trailer",
                eCommerce: "",
                deactivate: "",
                suppressPrinting: "",
                parentDepartment: "",
                scaleDepartmentId: 0,
                groups: angular.copy(groupList)
            },
            {
                ID: 3,
                name: "Axles",
                desc: "Axles",
                eCommerce: "",
                deactivate: "",
                suppressPrinting: "",
                parentDepartment: "",
                scaleDepartmentId: 0,
                groups: angular.copy(groupList)
            },
            {
                ID: 4,
                name: "Active Shoes",
                desc: "Active Shoes",
                eCommerce: "",
                deactivate: "",
                suppressPrinting: "",
                parentDepartment: "",
                scaleDepartmentId: 0,
                groups: angular.copy(groupList)
            },
            {
                ID: 5,
                name: "Additions",
                desc: "Additions",
                eCommerce: "",
                deactivate: "",
                suppressPrinting: "",
                parentDepartment: "",
                scaleDepartmentId: 0,
                groups: angular.copy(groupList)
            },
            {
                ID: 6,
                name: "Adhesive",
                desc: "Adhesive",
                eCommerce: "",
                deactivate: "",
                suppressPrinting: "",
                parentDepartment: "",
                scaleDepartmentId: 0,
                groups: angular.copy(groupList)
            },
            {
                ID: 7,
                name: "Admissions",
                desc: "Admissions",
                eCommerce: "",
                deactivate: "",
                suppressPrinting: "",
                parentDepartment: "",
                scaleDepartmentId: 0,
                groups: angular.copy(groupList)
            },
            {
                ID: 8,
                name: "Adult",
                desc: "Adult",
                eCommerce: "",
                deactivate: "",
                suppressPrinting: "",
                parentDepartment: "",
                scaleDepartmentId: 0,
                groups: angular.copy(groupList)
            },
            {
                ID: 9,
                name: "Adult Activity",
                desc: "Adult Activity",
                eCommerce: "",
                deactivate: "",
                suppressPrinting: "",
                parentDepartment: "",
                scaleDepartmentId: 0,
                groups: angular.copy(groupList)
            },
            {
                ID: 10,
                name: "Age 16+",
                desc: "Age 16+",
                eCommerce: "",
                deactivate: "",
                suppressPrinting: "",
                parentDepartment: "",
                scaleDepartmentId: 0,
                groups: angular.copy(groupList)
            },
            {
                ID: 11,
                name: "Age 35",
                desc: "Age 35",
                eCommerce: "",
                deactivate: "",
                suppressPrinting: "",
                parentDepartment: "",
                scaleDepartmentId: 0,
                groups: angular.copy(groupList)
            },
            {
                ID: 12,
                name: "Age 6.15",
                desc: "Age 6.15",
                eCommerce: "",
                deactivate: "",
                suppressPrinting: "",
                parentDepartment: "",
                scaleDepartmentId: 0,
                groups: angular.copy(groupList)
            },
            {
                ID: 13,
                name: "Agriculture",
                desc: "Agriculture",
                eCommerce: "",
                deactivate: "",
                suppressPrinting: "",
                parentDepartment: "",
                scaleDepartmentId: 0,
                groups: angular.copy(groupList)
            },
            {
                ID: 14,
                name: "Air",
                desc: "Air",
                eCommerce: "",
                deactivate: "",
                suppressPrinting: "",
                parentDepartment: "",
                scaleDepartmentId: 0,
                groups: angular.copy(groupList)
            },
            {
                ID: 15,
                name: "Airbrush",
                desc: "Airbrush",
                eCommerce: "",
                deactivate: "",
                suppressPrinting: "",
                parentDepartment: "",
                scaleDepartmentId: 0,
                groups: angular.copy(groupList)
            },
            {
                ID: 16,
                name: "Alcohol",
                desc: "Alcohol",
                eCommerce: "",
                deactivate: "",
                suppressPrinting: "",
                parentDepartment: "",
                scaleDepartmentId: 0,
                groups: angular.copy(groupList)
            },
            {
                ID: 17,
                name: "Alied",
                desc: "Alied",
                eCommerce: "",
                deactivate: "",
                suppressPrinting: "",
                parentDepartment: "",
                scaleDepartmentId: 0,
                groups: angular.copy(groupList)
            },
            {
                ID: 18,
                name: "Amino Acids",
                desc: "Amino Acids",
                eCommerce: "",
                deactivate: "",
                suppressPrinting: "",
                parentDepartment: "",
                scaleDepartmentId: 0,
                groups: angular.copy(groupList)
            },
            {
                ID: 19,
                name: "Ankle Support",
                desc: "Ankle Support",
                eCommerce: "",
                deactivate: "",
                suppressPrinting: "",
                parentDepartment: "",
                scaleDepartmentId: 0,
                groups: angular.copy(groupList)
            }
		];

		return {
			 getDepartments : function(searchText) {
                return $filter('filter')(departments, {name: searchText})
             },
             getGroupList : function() {
                return groupList;
            },
            getDepartmentList : function() {
                return departmentList;
            },
			 addDepartment : function(department) {
				var temp = {
                    ID: elementId++,
					name: department.name,
                    desc: department.desc,
                    eCommerce: department.eCommerce,
                    deactivate: department.deactivate,
                    suppressPrinting: department.suppressPrinting,
                    parentDepartment: department.parentDepartment,
                    scaleDepartmentId: department.scaleDepartmentId,
                    groups: angular.copy(department.groups)
				}

				departments.push(temp);
			 },
			 deleteDepartment: function(item) {
                var index = departments.findIndex(department => department.ID == item.ID);
                departments.splice(index, 1);
             },
			 saveDepartment: function(item,department) {
                var index = departments.findIndex(department => department.ID == item.ID);
				departments[index].name = department.name;
                departments[index].desc = department.desc;
                departments[index].eCommerce = department.eCommerce;
                departments[index].deactivate = department.deactivate;
                departments[index].suppressPrinting = department.suppressPrinting;
                departments[index].parentDepartment = department.parentDepartment;
                departments[index].scaleDepartmentId = (department.scaleDepartmentId != undefined? department.scaleDepartmentId: 0);
                departments[index].groups = angular.copy(department.groups);
			},
			getDepartmentByIndex : function(item) {
                return departments.filter(department => department.ID == item.ID)[0];
            }
		};
    });
    
    module.directive('selectOnClick', ['$window', function ($window) {
        if(ionic.Platform.isIOS()) {
            return {
                restrict: 'A',
                link: function (scope, element, attrs) {
                    element.on('click', function () {
                        if (!$window.getSelection().toString()) {
                            this.setSelectionRange(0, this.value.length)
                        }
                    });
                }
            };
        }
        else {
            return {
                restrict: 'A',
                link: function (scope, element) {
                    var focusedElement;
                    element.on('click', function () {
                        this.select();
                        focusedElement = this;
                    });
                    element.on('blur', function () {
                        focusedElement = null;
                    });
                }
            };
        }
    }]);
	
	module.config(['$stateProvider', '$provide', '$urlRouterProvider',
	'$httpProvider', function ($stateProvider, $provide, $urlRouterProvider, $httpProvider) {
		$stateProvider
		.state('tab.departments', {
			url: '/departments',
			LoginRequired: true,
			views: {
				'tab-view': {
					templateUrl: 'modules/common_html/templates/view.html',
					controller: 'DepartmentController'
				}
			}
		})
		.state('tab.editdepartments', {
			url: '/editdepartment/:name',
            LoginRequired: true,
            views: {
				'tab-view': {
					templateUrl: 'modules/departments/templates/departments-edit.html',
                    controller: 'EditDepartmentController'
				}
			}
		})
		.state('tab.adddepartments', {
			url: '/editdepartment/:name',
            LoginRequired: true,
            views: {
				'tab-view': {
					templateUrl: 'modules/departments/templates/departments-edit.html',
                    controller: 'AddDepartmentController'
				}
			}	
		})
	}]);

    module.controller('DepartmentController', function($scope,$state,$ionicPopup,$filter,$rootScope,$ionicScrollDelegate,departmentFactory){
        $scope.selectedItem = null;
        $scope.itemSelected = false;
        $scope.title = "Manage Departments";
        $scope.searchTitle = "Departments"

        
       

        
            
            {
        }

        $scope.gotoAddEditPage = function(pagename){
            if(pagename == 'edit' && $scope.selectedItem != null){
                $state.go('tab.editdepartments',{name: JSON.stringify($scope.selectedItem)});
            }
            if(pagename == 'add'){
                $state.go('tab.adddepartments',{name: 'add'});
            } 
        }

        $scope.setSelectedItem = function(item) {
            $scope.selectedItem = item;
            $scope.itemSelected = true;
        }

        $scope.clearSelectedItem = function() {
            $scope.selectedItem = null;
            $scope.itemSelected = false;
        }

        $scope.deleteItem = function() {
            if($scope.selectedItem != null) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Are you sure you want to delete?',
                    cancelText: 'No',
                    okText: 'Yes'
                }).then(function(val) {
                    if(val == true){
                        departmentFactory.deleteDepartment($scope.selectedItem);
                        $rootScope.$emit('updateDepartments', {
                            editType: "Deleted"
                        });
                    }
                })
            }
        }
        $scope.searchItem = function() {
            $scope.entries = angular.copy(departmentFactory.getDepartments($scope.searchContent));
            $scope.showContent = true;
            $scope.clearSelectedItem();
            $scope.scrollMainToTop();
        }
        
        $rootScope.$on('updateDepartments', function(event, arg) {
            $scope.entries = angular.copy(departmentFactory.getDepartments($scope.searchContent));
        });
        
        $scope.scrollMainToTop = function() {
             $ionicScrollDelegate.$getByHandle('mainScroll').scrollTop();
        };
    })

    module.controller('EditDepartmentController', function($scope,$state,$stateParams,$ionicPopup,$ionicHistory,$rootScope,departmentFactory,$filter){
        $scope.selectedItem = angular.copy(JSON.parse($stateParams.name));
        $scope.department = angular.copy(departmentFactory.getDepartmentByIndex($scope.selectedItem));
        $scope.department.groups = $filter('orderBy')($scope.department.groups,['-value','name']);
        $scope.searchTitle = $scope.department.name;
        $scope.title = "Edit Department";
        $scope.departmentList = angular.copy(departmentFactory.getDepartmentList());

        
       

        
            
            {
        }

        $scope.autoFillDescription = function() {
            if($scope.department.desc.length == 0) {
                $scope.department.desc = $scope.department.name;
            }
        }

        $scope.goBack = function() {
            var Department = angular.copy(departmentFactory.getDepartmentByIndex($scope.selectedItem));
            Department.groups = $filter('orderBy')(Department.groups,['-value','name']);
            
            if(!angular.equals($scope.department, Department)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        var errorCheck = document.getElementsByClassName('error-message');
                        var validity = true;
                        for(var i = 0; i < errorCheck.length; i++) {
                            if(errorCheck[i].classList.length == 1 && errorCheck[i].classList[0] == "error-message") {
                                validity = false;
                            }
                        }
            
                        if(validity) {
                            departmentFactory.saveDepartment($scope.selectedItem,$scope.department);
                            $rootScope.$emit('updateDepartments', {
                                editType: "Saved"
                            });
                            var popupMessage = $ionicPopup.alert( {
                                title: 'Record saved successfully.',
                                subTitle: ''
                            })
                            $scope.department.groups = $filter('orderBy')($scope.department.groups,['-value','name']);
                            $ionicHistory.goBack();
                        } else {
                            var popupMessage = $ionicPopup.alert( {
                                title: 'Invalid Input.',
                                subTitle: ''
                            })
                        }
                    } else {
                        $ionicHistory.goBack();
                    }
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }
        
        $scope.saveDepartment = function() {
            var errorCheck = document.getElementsByClassName('error-message');
            var validity = true;
            for(var i = 0; i < errorCheck.length; i++) {
                if(errorCheck[i].classList.length == 1 && errorCheck[i].classList[0] == "error-message") {
                    validity = false;
                }
            }

            if(validity) {
                departmentFactory.saveDepartment($scope.selectedItem,$scope.department);
                $rootScope.$emit('updateDepartments', {
                    editType: "Saved"
                });
                var popupMessage = $ionicPopup.alert( {
                    title: 'Record saved successfully.',
                    subTitle: ''
                })
                $scope.department.groups = $filter('orderBy')($scope.department.groups,['-value','name']);
            } else {
                var popupMessage = $ionicPopup.alert( {
                    title: 'Invalid Input.',
                    subTitle: ''
                })
            }
        }

        $scope.clearDepartment = function() {
            var Department = angular.copy(departmentFactory.getDepartmentByIndex($scope.selectedItem));
            Department.groups = $filter('orderBy')(Department.groups,['-value','name']);

            if(!angular.equals($scope.department, Department)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        $scope.saveDepartment();
                    }
                    else{
                        $scope.department = angular.copy(departmentFactory.getDepartmentByIndex($scope.selectedItem));
                        $scope.department.groups = $filter('orderBy')($scope.department.groups,['-value','name']);
                    }
                })
            }
        }

        $scope.deleteDepartment = function() {
            var popupMessage = $ionicPopup.confirm( {
                title: 'Are you sure you want to delete?',
                cancelText: 'No',
                okText: 'Yes'
            }).then(function(val) {
                if(val == true){
                    departmentFactory.deleteDepartment($scope.selectedItem);
                    $rootScope.$emit('updateDepartments', {
                        editType: "Deleted"
                    });
                    $ionicHistory.goBack(); 
                }
            })
        }

        $scope.cancelEdit = function() {
            var Department = angular.copy(departmentFactory.getDepartmentByIndex($scope.selectedItem));
            Department.groups = $filter('orderBy')(Department.groups,['-value','name']);
            
            if(!angular.equals($scope.department, Department)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Are you sure you want to cancel?',
                    cancelText: 'No',
                    okText: 'Yes'
                }).then(function(val) {
                    if(val == true){
                        $scope.department = angular.copy(departmentFactory.getDepartmentByIndex($scope.selectedItem));
                        $scope.department.groups = $filter('orderBy')($scope.department.groups,['-value','name']);
                    }
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }
    })

    module.controller('AddDepartmentController', function($scope,$ionicPopup,$ionicHistory,$rootScope,departmentFactory){
        $scope.showSearchbar = true;
        $scope.title = "Add Department";
        $scope.departmentList = angular.copy(departmentFactory.getDepartmentList());
        $scope.department = {
            name : "",
            desc : "",
            eCommerce: "",
            deactivate: "",
            suppressPrinting: "",
            parentDepartment: "",
            scaleDepartmentId: 0,
            groups: angular.copy(departmentFactory.getGroupList())
        }
        var oriDepartment = angular.copy($scope.department);

        $scope.autoFillDescription = function() {
            if($scope.department.desc.length == 0) {
                $scope.department.desc = angular.copy($scope.department.name);
            }
        }

        
       //var margintop = 75 + subtoppadding - 55;

        
            
            {
        }

        $scope.goBack = function() {
            if(!angular.equals($scope.department, oriDepartment)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        var errorCheck = document.getElementsByClassName('error-message');
                        var validity = true;
                        for(var i = 0; i < errorCheck.length; i++) {
                            if(errorCheck[i].classList.length == 1 && errorCheck[i].classList[0] == "error-message") {
                                validity = false;
                            }
                        }
            
                        if(validity) {
                            departmentFactory.addDepartment($scope.department);
                            $rootScope.$emit('updateDepartments', {
                                editType: "Added"
                            });
                            var popupMessage = $ionicPopup.alert( {
                                title: 'Record saved successfully.',
                                subTitle: ''
                            }).then(function() {
                                $scope.department = angular.copy(oriDepartment);
                            })
                            $ionicHistory.goBack();
                        } else {
                            var popupMessage = $ionicPopup.alert( {
                                title: 'Invalid Input.',
                                subTitle: ''
                            })
                        } 
                    } else {
                        $ionicHistory.goBack();
                    }
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }

        $scope.saveDepartment = function() {
            if(!angular.equals($scope.department, oriDepartment)) {
                var errorCheck = document.getElementsByClassName('error-message');
                var validity = true;
                for(var i = 0; i < errorCheck.length; i++) {
                    if(errorCheck[i].classList.length == 1 && errorCheck[i].classList[0] == "error-message") {
                        validity = false;
                    }
                }
    
                if(validity) {
                    departmentFactory.addDepartment($scope.department);
                    $rootScope.$emit('updateDepartments', {
                        editType: "Added"
                    });
                    var popupMessage = $ionicPopup.alert( {
                        title: 'Record saved successfully.',
                        subTitle: ''
                    }).then(function() {
                        $scope.department = angular.copy(oriDepartment);
                    })
                } else {
                    var popupMessage = $ionicPopup.alert( {
                        title: 'Invalid Input.',
                        subTitle: ''
                    })
                }
            }
        }

        $scope.addDepartment = function() {
            $scope.clearDepartment();
        }

        $scope.clearDepartment = function() {
            if(!angular.equals($scope.department, oriDepartment)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        $scope.saveDepartment(); 
                    }
                    $scope.department = angular.copy(oriDepartment);
                })
            }
        }

        $scope.cancelEdit = function() {
            if(!angular.equals($scope.department, oriDepartment)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Are you sure you want to cancel?',
                    cancelText: 'No',
                    okText: 'Yes'
                }).then(function(val) {
                    if(val == true){
                        $scope.department = angular.copy(oriDepartment); 
                    }
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }
    })
})();