(function () {
    
	var module = angular.module('aralco.dimensions',['ionic']);
	
	module.factory('dimensionFactory', function($filter) {

        var elementId = 26;

        var valueList = [
            {
                ID: 1,
                name: "001 Black",
                desc: "001 Black",
                deactivate: false
            },
            {
                ID: 2,
                name: "100 White",
                desc: "100 White",
                deactivate: false
            },
            {
                ID: 3,
                name: "1245black",
                desc: "1245black",
                deactivate: false
            },
            {
                ID: 4,
                name: "228 Palm",
                desc: "228 Palm",
                deactivate: false
            },
            {
                ID: 5,
                name: "8403 N/BEI",
                desc: "8403 N/BEI",
                deactivate: false
            },
            {
                ID: 6,
                name: "AIR FORCE",
                desc: "AIR FORCE",
                deactivate: false
            },
            {
                ID: 7,
                name: "AMBER",
                desc: "AMBER",
                deactivate: false
            },
            {
                ID: 8,
                name: "AMETHYST",
                desc: "AMETHYST",
                deactivate: false
            },
            {
                ID: 9,
                name: "Apple Green",
                desc: "Apple Green",
                deactivate: false
            },
            {
                ID: 10,
                name: "Aqua",
                desc: "Aqua",
                deactivate: false
            },
            {
                ID: 11,
                name: "Ash Wth Stripe",
                desc: "Ash Wth Stripe",
                deactivate: false
            },
            {
                ID: 12,
                name: "AUBERGINE",
                desc: "AUBERGINE",
                deactivate: false
            },
            {
                ID: 13,
                name: "bamboo",
                desc: "bamboo",
                deactivate: false
            },
            {
                ID: 14,
                name: "BARK",
                desc: "BARK",
                deactivate: false
            },
            {
                ID: 15,
                name: "BEIGE",
                desc: "BEIGE",
                deactivate: false
            },
            {
                ID: 16,
                name: "BERRY",
                desc: "BERRY",
                deactivate: false
            },
            {
                ID: 17,
                name: "biscuit",
                desc: "biscuit",
                deactivate: false
            },
            {
                ID: 18,
                name: "Black",
                desc: "Black",
                deactivate: false
            },
            {
                ID: 19,
                name: "black 797",
                desc: "black 797",
                deactivate: false
            },
            {
                ID: 20,
                name: "BLACK A",
                desc: "BLACK A",
                deactivate: false
            },
            {
                ID: 21,
                name: "BLACK B",
                desc: "BLACK B",
                deactivate: false
            },
            {
                ID: 22,
                name: "Black Brown 961",
                desc: "Black Brown 961",
                deactivate: false
            },
            {
                ID: 23,
                name: "Black Brown 962",
                desc: "Black Brown 962",
                deactivate: false
            },
            {
                ID: 24,
                name: "BLACK C",
                desc: "BLACK C",
                deactivate: false
            },
            {
                ID: 25,
                name: "BLACK D",
                desc: "BLACK D",
                deactivate: false
            }
        ];

		var dimensions = [
			{
                ID: 1,
                name: "C Lengths",
                desc: "C Lengths",
                type: "table",
                eCommerce: false,
                deactivate: false,
                values: angular.copy(valueList)
            },
            {
                ID: 2,
                name: "Calf Size",
                desc: "Calf Size",
                type: "table",
                eCommerce: false,
                deactivate: false,
                values: angular.copy(valueList)
            },
            {
                ID: 3,
                name: "Careat / Weight",
                desc: "Careat / Weight",
                type: "table",
                eCommerce: false,
                deactivate: false,
                values: angular.copy(valueList)
            },
            {
                ID: 4,
                name: "CB Colour",
                desc: "CB Colour",
                type: "table",
                eCommerce: false,
                deactivate: false,
                values: angular.copy(valueList)
            },
            {
                ID: 5,
                name: "CB Height",
                desc: "CB Height",
                type: "table",
                eCommerce: false,
                deactivate: false,
                values: angular.copy(valueList)
            },
            {
                ID: 6,
                name: "CB Width",
                desc: "CB Width",
                type: "table",
                eCommerce: false,
                deactivate: false,
                values: angular.copy(valueList)
            },
            {
                ID: 7,
                name: "Chain Length",
                desc: "Chain Length",
                type: "table",
                eCommerce: false,
                deactivate: false,
                values: angular.copy(valueList)
            },
            {
                ID: 8,
                name: "Chain Metal",
                desc: "Chain Metal",
                type: "table",
                eCommerce: false,
                deactivate: false,
                values: angular.copy(valueList)
            },
            {
                ID: 9,
                name: "Chain Type",
                desc: "Chain Type",
                type: "table",
                eCommerce: false,
                deactivate: false,
                values: angular.copy(valueList)
            },
            {
                ID: 10,
                name: "Chest Size",
                desc: "Chest Size",
                type: "table",
                eCommerce: false,
                deactivate: false,
                values: angular.copy(valueList)
            },
            {
                ID: 11,
                name: "Clarity",
                desc: "Clarity",
                type: "table",
                eCommerce: false,
                deactivate: false,
                values: angular.copy(valueList)
            },
            {
                ID: 12,
                name: "Class Time",
                desc: "Class Time",
                type: "table",
                eCommerce: false,
                deactivate: false,
                values: angular.copy(valueList)
            },
            {
                ID: 13,
                name: "Class Type",
                desc: "Class Type",
                type: "table",
                eCommerce: false,
                deactivate: false,
                values: angular.copy(valueList)
            },
            {
                ID: 14,
                name: "Colors",
                desc: "Colors",
                type: "table",
                eCommerce: false,
                deactivate: false,
                values: angular.copy(valueList)
            },
            {
                ID: 15,
                name: "Condition",
                desc: "Condition",
                type: "table",
                eCommerce: false,
                deactivate: false,
                values: angular.copy(valueList)
            },
            {
                ID: 16,
                name: "Consultation",
                desc: "Consultation",
                type: "table",
                eCommerce: false,
                deactivate: false,
                values: angular.copy(valueList)
            },
            {
                ID: 17,
                name: "Control",
                desc: "Control",
                type: "table",
                eCommerce: false,
                deactivate: false,
                values: angular.copy(valueList)
            },
            {
                ID: 18,
                name: "Covers",
                desc: "Covers",
                type: "table",
                eCommerce: false,
                deactivate: false,
                values: angular.copy(valueList)
            },
            {
                ID: 19,
                name: "Cup Style",
                desc: "Cup Style",
                type: "table",
                eCommerce: false,
                deactivate: false,
                values: angular.copy(valueList)
            }
		];

		return {
			 getDimensions : function(searchText) {
                return $filter('filter')(dimensions, {name: searchText})
             },
             getValueList : function() {
                return valueList;
            },
            addDimension : function(dimension) {
                var temp = {
                    ID: elementId++,
                    name: dimension.name,
                    desc: dimension.desc,
                    eCommerce: dimension.eCommerce,
                    deactivate: dimension.deactivate,
                    type: dimension.type,
                    values: angular.copy(dimension.values)
                }

                dimensions.push(temp);
            },
            addDimensionValue : function(value,dimension) {
                var dimensionIndex = dimensions.findIndex(Dimension => Dimension.ID == dimension.ID);
                var valueLength = dimensions[dimensionIndex].values.length - 1
                var temp = {
                    ID: dimensions[dimensionIndex].values[valueLength].ID + 1,
                    name: value.name,
                    desc: value.desc,
                    deactivate: value.deactivate,
                }

                dimensions[dimensionIndex].values.push(temp);
            },
            deleteDimension: function(item) {
                var index = dimensions.findIndex(dimension => dimension.ID == item.ID);
                dimensions.splice(index, 1);
            },
            deleteDimensionValue: function(dimension, value) {
                var dimensionIndex = dimensions.findIndex(Dimension => Dimension.ID == dimension.ID);
                var valueIndex = dimensions[dimensionIndex].values.findIndex(Value => Value.ID == value.ID);
                dimensions[dimensionIndex].values.splice(valueIndex, 1);
            },
            saveDimension: function(item,dimension) {
                var index = dimensions.findIndex(dimension => dimension.ID == item.ID);
                dimensions[index].name = dimension.name;
                dimensions[index].desc = dimension.desc;
                dimensions[index].eCommerce = dimension.eCommerce;
                dimensions[index].deactivate = dimension.deactivate;
                dimensions[index].type = dimension.type;
                dimensions[index].values = angular.copy(dimension.values);
            },
            saveDimensionValue: function(dimension, value, newValue) {
                var dimensionIndex = dimensions.findIndex(Dimension => Dimension.ID == dimension.ID);
                var valueIndex = dimensions[dimensionIndex].values.findIndex(Value => Value.ID == value.ID);
                dimensions[dimensionIndex].values[valueIndex].name = newValue.name;
                dimensions[dimensionIndex].values[valueIndex].desc = newValue.desc;
                dimensions[dimensionIndex].values[valueIndex].deactivate = newValue.deactivate;
            },
			getDimensionByIndex : function(item) {
                return dimensions.filter(dimension => dimension.ID == item.ID)[0];
            },            
            getDimensionValueByIndex : function(dimension, value) {
                var dimensionIndex = dimensions.findIndex(Dimension => Dimension.ID == dimension.ID);
                return dimensions[dimensionIndex].values.filter(Value => Value.ID == value.ID)[0];
            }
		};
    });
	
	module.config(['$stateProvider', '$provide', '$urlRouterProvider',
	'$httpProvider', function ($stateProvider, $provide, $urlRouterProvider, $httpProvider) {
		$stateProvider
		.state('tab.dimensions', {
			url: '/dimensions',
			LoginRequired: true,
			views: {
				'tab-view': {
					templateUrl: 'modules/common_html/templates/view.html',
					controller: 'DimensionController'
				}
			}
		})
		.state('tab.editdimensions', {
			url: '/editdimension/:name',
            LoginRequired: true,
            views: {
				'tab-view': {
					templateUrl: 'modules/dimensions/templates/dimensions-edit.html',
                    controller: 'EditDimensionController'
				}
			}
		})
		.state('tab.adddimensions', {
			url: '/editdimension/:name',
            LoginRequired: true,
            views: {
				'tab-view': {
					templateUrl: 'modules/dimensions/templates/dimensions-edit.html',
                    controller: 'AddDimensionController'
				}
			}	
        })
        .state('tab.editdimensionvalue', {
			url: '/editdimensionvalue/:name/:value',
            LoginRequired: true,
            views: {
				'tab-view': {
					templateUrl: 'modules/dimensions/templates/values-edit.html',
                    controller: 'EditDimensionValueController'
				}
			}
		})
		.state('tab.adddimensionvalue', {
			url: '/editdimensionvalue/:name',
            LoginRequired: true,
            views: {
				'tab-view': {
					templateUrl: 'modules/dimensions/templates/values-edit.html',
                    controller: 'AddDimensionValueController'
				}
			}	
		})
	}]);

    module.controller('DimensionController', function($scope,$state,$ionicPopup,$filter,$rootScope,$ionicScrollDelegate,dimensionFactory){
        $scope.selectedItem = null;
        $scope.itemSelected = false;
        $scope.title = "Manage Dimensions";
        $scope.searchTitle = "Dimensions";

        
       

        
            
            {
        }

        $scope.gotoAddEditPage = function(pagename){
            if(pagename == 'edit' && $scope.selectedItem != null){
                $state.go('tab.editdimensions',{name: JSON.stringify($scope.selectedItem)});
            }
            if(pagename == 'add'){
                $state.go('tab.adddimensions',{name: 'add'});
            } 
        }

        $scope.setSelectedItem = function(item) {
            $scope.selectedItem = item;
            $scope.itemSelected = true;
        }

        $scope.clearSelectedItem = function() {
            $scope.selectedItem = null;
            $scope.itemSelected = false;
        }

        $scope.deleteItem = function() {
            if($scope.selectedItem != null) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Are you sure you want to delete?',
                    cancelText: 'No',
                    okText: 'Yes'
                }).then(function(val) {
                    if(val == true){
                        dimensionFactory.deleteDimension($scope.selectedItem);
                        $rootScope.$emit('updateDimensions', {
                            editType: "Deleted"
                        });
                    }
                })
            }
        }

        $scope.searchItem = function() {
            $scope.entries = angular.copy(dimensionFactory.getDimensions($scope.searchContent));
            $scope.showContent = true;
            $scope.clearSelectedItem();
            $scope.scrollMainToTop();
        }
        
        $rootScope.$on('updateDimensions', function(event, arg) {
            $scope.entries = angular.copy(dimensionFactory.getDimensions($scope.searchContent));
        });
        
        $scope.scrollMainToTop = function() {
             $ionicScrollDelegate.$getByHandle('mainScroll').scrollTop();
        };
    })

    module.controller('EditDimensionController', function($scope,$rootScope,$state,$stateParams,$ionicPopup,$ionicHistory,dimensionFactory){
        $scope.selectedItem = angular.copy(JSON.parse($stateParams.name));
        $scope.dimension = angular.copy(dimensionFactory.getDimensionByIndex($scope.selectedItem));
        $scope.searchTitle = $scope.dimension.name;
        $scope.title = "Edit Dimension";

        $rootScope.$on('updateDimensionValues', function (event, arg) {
            $scope.dimension.values = angular.copy(dimensionFactory.getDimensionByIndex(arg.dimension).values);
        });

        
       

        
            
            {
        }

        $scope.autoFillDescription = function() {
            if($scope.dimension.desc.length == 0) {
                $scope.dimension.desc = $scope.dimension.name;
            }
        }

        $scope.goBack = function() {
            if(!angular.equals($scope.dimension, dimensionFactory.getDimensionByIndex($scope.selectedItem))) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        $scope.saveDimension();
                    }
                    $ionicHistory.goBack();
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }
        
        $scope.saveDimension = function() {
            dimensionFactory.saveDimension($scope.selectedItem,$scope.dimension);
            $rootScope.$emit('updateDimensions', {
                editType: "Saved"
            });
            var popupMessage = $ionicPopup.alert( {
                title: 'Record saved successfully.',
                subTitle: ''
            })
        }

        $scope.clearDimension = function() {
            if(!angular.equals($scope.dimension, dimensionFactory.getDimensionByIndex($scope.selectedItem))) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        $scope.saveDimension();
                    }
                    else{
                        $scope.dimension = angular.copy(dimensionFactory.getDimensionByIndex($scope.selectedItem));
                    }
                })
            }
        }

        $scope.deleteDimension = function() {
            var popupMessage = $ionicPopup.confirm( {
                title: 'Are you sure you want to delete?',
                cancelText: 'No',
                okText: 'Yes'
            }).then(function(val) {
                if(val == true){
                    dimensionFactory.deleteDimension($scope.selectedItem);
                    $rootScope.$emit('updateDimensions', {
                        editType: "Deleted"
                    });
                    $ionicHistory.goBack(); 
                }
            })
        }

        $scope.cancelEdit = function() {
            if(!angular.equals($scope.dimension, dimensionFactory.getDimensionByIndex($scope.selectedItem))) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Are you sure you want to cancel?',
                    cancelText: 'No',
                    okText: 'Yes'
                }).then(function(val) {
                    if(val == true){
                        $scope.dimension = angular.copy(dimensionFactory.getDimensionByIndex($scope.selectedItem));
                    }
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }

        $scope.addDimension = function() {
            $state.go('tab.adddimensionvalue',{name: JSON.stringify($scope.selectedItem)});
        }

        $scope.editDimensionValue = function(value) {
            $state.go('tab.editdimensionvalue',{name: JSON.stringify($scope.selectedItem), value: JSON.stringify(value)});
        }
    })

    module.controller('AddDimensionController', function($scope,$ionicPopup,$ionicHistory,$rootScope,dimensionFactory){
        $scope.showSearchbar = true;
        $scope.title = "Add Dimension";
        $scope.dimension = {
            name : "",
            desc : "",
            eCommerce: "",
            deactivate: "",
            type: "table",
            values: angular.copy(dimensionFactory.getValueList())
        }
        var oriDimension = angular.copy($scope.dimension);

        $scope.autoFillDescription = function() {
            if($scope.dimension.desc.length == 0) {
                $scope.dimension.desc = angular.copy($scope.dimension.name);
            }
        }

        
       //var margintop = 75 + subtoppadding - 55;

        
            
            {
        }

        $scope.goBack = function() {
            if(!angular.equals($scope.dimension, oriDimension)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        dimensionFactory.addDimension($scope.dimension);
                        $rootScope.$emit('updateDimensions', {
                            editType: "Added"
                        });
                        var popupMessage = $ionicPopup.alert( {
                            title: 'Record saved successfully.',
                            subTitle: ''
                        }).then(function() {
                            $scope.dimension = angular.copy(oriDimension);
                        })
                        $ionicHistory.goBack();
                    } else {
                        $ionicHistory.goBack();
                    }
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }

        $scope.saveDimension = function() {
            if(!angular.equals($scope.dimension, oriDimension)) {
                dimensionFactory.addDimension($scope.dimension);
                $rootScope.$emit('updateDimensions', {
                    editType: "Added"
                });
                var popupMessage = $ionicPopup.alert( {
                    title: 'Record saved successfully.',
                    subTitle: ''
                }).then(function() {
                    $scope.dimension = angular.copy(oriDimension);
                })
            }
        }

        $scope.addDimension = function() {
            $scope.clearDimension();
        }

        $scope.clearDimension = function() {
            if(!angular.equals($scope.dimension, oriDimension)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        $scope.saveDimension(); 
                    }
                    $scope.dimension = angular.copy(oriDimension);
                })
            }
        }

        $scope.cancelEdit = function() {
            if(!angular.equals($scope.dimension, oriDimension)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Are you sure you want to cancel?',
                    cancelText: 'No',
                    okText: 'Yes'
                }).then(function(val) {
                    if(val == true){
                        $scope.dimension = angular.copy(oriDimension); 
                    }
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }
    })

    module.controller('EditDimensionValueController', function($scope,$rootScope,$state,$stateParams,$ionicPopup,$ionicHistory,dimensionFactory){
        $scope.selectedDimension = angular.copy(JSON.parse($stateParams.name));
        $scope.selectedValue = angular.copy(JSON.parse($stateParams.value));
        $scope.value = angular.copy(dimensionFactory.getDimensionValueByIndex($scope.selectedDimension, $scope.selectedValue));
        $scope.searchTitle = $scope.value.name;
        $scope.title = "Edit Dimension Value";

        
       

        
            
            {
        }

        $scope.autoFillDescription = function() {
            if($scope.value.desc.length == 0) {
                $scope.value.desc = $scope.value.name;
            }
        }

        $scope.goBack = function() {
            if(!angular.equals($scope.value, dimensionFactory.getDimensionValueByIndex($scope.selectedDimension, $scope.selectedValue))) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                       $scope.saveDimensionValue();
                    }
                    $ionicHistory.goBack();
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }
        
        $scope.saveDimensionValue = function() {
            dimensionFactory.saveDimensionValue($scope.selectedDimension, $scope.selectedValue, $scope.value);
            $rootScope.$emit('updateDimensionValues', {
                dimension: $scope.selectedDimension,
                editType: "Saved"
            });
            var popupMessage = $ionicPopup.alert( {
                title: 'Record saved successfully.',
                subTitle: ''
            })
        }

        $scope.clearDimensionValue = function() {
            if(!angular.equals($scope.value, dimensionFactory.getDimensionValueByIndex($scope.selectedDimension, $scope.selectedValue))) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        $scope.saveDimensionValue();
                    }
                    else{
                        $scope.value = angular.copy(dimensionFactory.getDimensionValueByIndex($scope.selectedDimension, $scope.selectedValue));
                    }
                })
            }
        }

        $scope.deleteDimensionValue = function() {
            var popupMessage = $ionicPopup.confirm( {
                title: 'Are you sure you want to delete?',
                cancelText: 'No',
                okText: 'Yes'
            }).then(function(val) {
                if(val == true){
                    dimensionFactory.deleteDimensionValue($scope.selectedDimension, $scope.selectedValue);
                    $rootScope.$emit('updateDimensionValues', {
                        dimension: $scope.selectedDimension,
                        editType: "Deleted"
                    });
                    $ionicHistory.goBack(); 
                }
            })
        }

        $scope.cancelEditValue = function() {
            if(!angular.equals($scope.value, dimensionFactory.getDimensionValueByIndex($scope.selectedDimension, $scope.selectedValue))) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Are you sure you want to cancel?',
                    cancelText: 'No',
                    okText: 'Yes'
                }).then(function(val) {
                    if(val == true){
                        $scope.value = angular.copy(dimensionFactory.getDimensionValueByIndex($scope.selectedDimension, $scope.selectedValue));
                    }
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }
    })

    module.controller('AddDimensionValueController', function($scope,$rootScope,$stateParams,$ionicPopup,$ionicHistory,dimensionFactory){
        $scope.showSearchbar = true;
        $scope.selectedDimension = angular.copy(JSON.parse($stateParams.name));
        $scope.title = "Add Dimension Value";
        $scope.value = {
            name : "",
            desc : "",
            deactivate: ""
        }
        var oriValue = angular.copy($scope.value);

        $scope.autoFillDescription = function() {
            if($scope.value.desc.length == 0) {
                $scope.value.desc = angular.copy($scope.value.name);
            }
        }

        
       //var margintop = 75 + subtoppadding - 55;

        
            
            {
        }

        $scope.goBack = function() {
            if(!angular.equals($scope.value, oriValue)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        $scope.saveDimensionValue();
                    }
                    $ionicHistory.goBack();
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }

        $scope.saveDimensionValue = function() {
            if(!angular.equals($scope.value, oriValue)) {
                dimensionFactory.addDimensionValue($scope.value,$scope.selectedDimension);
                $rootScope.$emit('updateDimensionValues', {
                    dimension: $scope.selectedDimension,
                    editType: "Added"
                });
                var popupMessage = $ionicPopup.alert( {
                    title: 'Record saved successfully.',
                    subTitle: ''
                }).then(function() {
                    $scope.value = angular.copy(oriValue);
                })
            }
        }

        $scope.addDimensionValue = function() {
            $scope.clearDimensionValue();
        }

        $scope.clearDimensionValue = function() {
            if(!angular.equals($scope.value, oriValue)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Save or Cancel changes',
                    cancelText: '<a class="button button-positive icon ion-close-circled"></a>',
                    okText: '<a class="button button-positive icon ion-checkmark-circled"></a>',
                    cancelType: 'button-positive'
                }).then(function(val) {
                    if(val == true){
                        $scope.saveDimensionValue(); 
                    }
                    $scope.value = angular.copy(oriValue);
                })
            }
        }

        $scope.cancelEditValue = function() {
            if(!angular.equals($scope.value, oriValue)) {
                var popupMessage = $ionicPopup.confirm( {
                    title: 'Are you sure you want to cancel?',
                    cancelText: 'No',
                    okText: 'Yes'
                }).then(function(val) {
                    if(val == true){
                        $scope.value = angular.copy(oriValue); 
                    }
                })
            }
            else {
                $ionicHistory.goBack();
            }
        }
    })
})();