﻿/// <reference path="../../js/aaralco.mobile.fwaralco.mobile.fw.js" />
(function () {

    var module = angular.module('aralco.images', []);

    module.service('ImgService', ['$q', '$http', function ($q, $http) {
        var self = this;

        var _parameter = {
            input: "",
            grids: {
                grid1: null,
                grid2: null,
                grid3: null,
                grid4: null
            },
            Type: null
        };


        function _search(req,ifempty) {

            generateUrl = function () {
                var url = $f.serviceUrl + "Images/Get/{identifier}/{type}/{Grid1}/{Grid2}/{Grid3}/{Grid4}?ForceLoad={ForceLoad}"
                url = url.replace("{identifier}", req.input);
                url = url.replace("{type}", req.Type || 1);
                url = url.replace("{Grid1}", req.grids.grid1 || 0);
                url = url.replace("{Grid2}", req.grids.grid2 || 0);
                url = url.replace("{Grid3}", req.grids.grid3 || 0);
                url = url.replace("{Grid4}", req.grids.grid4 || 0);
                url = url.replace("{ForceLoad}", $f.ForceLoad || false);
                return url;
            };
            ifempty = ifempty || $f.PhotoNotAvail;
            var deferred = $q.defer();
            if (_.isEmpty(req)) {
                deferred.resolve(null); //TO DO: Default Picure here
            }
            else {
                var req = {
                    method: 'get',
                    url: generateUrl()
                }

                $http(req).
                    success(function (data, status, headers, config) {
                        var Results = [{ value: ifempty }];
                        if (!_.isEmpty(data)) {
                            Results=[];
                            _.each(data, function (img) {
                                if (!_.isEmpty(img.value)) {
                                    img.value = 'data:image/png;base64,' + img.value;
                                }
                                else { 
                                    img.value = ifempty;
                                }
                                Results = Results || [];
                                Results.push(img);
                            });
                        };

                        deferred.resolve(Results)
                    }).
                    error(function (data, status) {
                        deferred.reject(data, status);
                    });
            }

            return deferred.promise;

        }

        self.SearchParam = _parameter;
        self.Search = _search;

        return self;
    }]);


})();
