﻿(function () {
    'use strict';
    var module = angular.module('aralco.physicalcount');

    module.controller('SnapshotListCtrl', ['$scope', '$q', '$stateParams', '$ionicSideMenuDelegate', '$ionicLoading', 'physicalCountFctr',
      function ($scope, $q, $stateParams, $ionicSideMenuDelegate, $ionicLoading, physicalCountFctr) {
        init();

        function init() {
            $scope.pcid = $stateParams.pcid;

            $scope.items = [];
            try {
                $ionicLoading.show({
                    template: 'Loading...'
                });
                physicalCountFctr.Snapshots.$getAll($scope.pcid).then(function (data) {
                    $scope.items = data;
                    $ionicLoading.hide()
                },
                function (data) {
                    $ionicLoading.hide()
                });
            } catch (e) {
                $ionicLoading.hide()
            }
        }
    }]);

})();