/// <reference path="../../js/models/scan.js" />
(function () {

    'use strict';
    var module = angular.module('aralco.transfers', ['ionic', 'aralco.database', 'aralco.sql', 'aralco.product','aralco.transfersControllers']);

    module.config(['$stateProvider','$urlRouterProvider', 
    function ($stateProvider, $urlRouterProvider) {
        // Each tab has its own nav history stack:
        $stateProvider.state('tab.transfers', {
            url: '/transfers',
            cache:false,
            views: {
                'tab-inventory': {
                    templateUrl: 'modules/inventory/transfers/templates/transfers-store-selection.html',
                    controller: 'TransfersCtrl'
                }
            }
        });
        $stateProvider.state('tab.transfers-scan', {
            url: '/transfers/scan/:fsid/:tsid',
            cache:false,
            views: {
                'tab-inventory': {
                    templateUrl: 'modules/inventory/transfers/templates/transfers-scan.html',
                    controller: 'TransfersScanCtrl'
                }
            }
        });
    }]);

    

}
)();