angular.module('aralco.productsDetails.controllers')
.controller('ProdDetailsCtrl', ['$ionicHistory', '$rootScope', 'prodSearchFctr', 'productDetailsDataFctr', 'departmentFctr', 'prodFctr', '$http', '$q', '$scope', '$state', 'errorFctr', '$ionicSideMenuDelegate', '$ionicLoading', '$filter', 'popupFctr', '$ionicModal',
    function ($ionicHistory,$rootScope, prodSearchFctr, productDetailsDataFctr, departmentFctr, prodFctr, $http, $q, $scope, $state, errorFctr, $ionicSideMenuDelegate, $ionicLoading, $filter, popupFctr, $ionicModal) {
              $scope.productCodeAvlbtyResponse="";
      $rootScope.$ionicGoBack = function(backCount) {
         var statusname = $ionicHistory.currentView().stateName;
         if(statusname == "tab.tax" || statusname == "tab.units" || statusname == "tab.supplier" || statusname == "tab.pricing"
            || statusname == "tab.properties" || statusname == "tab.grouping" || statusname == "tab.web" || statusname == "tab.ordering"
           || statusname == "tab.desc-pos" || statusname == "tab.pic-sound"){
            backCount = productDetailsDataFctr.getViewCountForBack();
          }
         $ionicHistory.goBack(backCount);
       }

      
          productDetailsDataFctr.setViewCountForBack(-1);
          $scope.newproductdetails = {};
          /* New product details modal */
           $ionicModal.fromTemplateUrl('modules/product_details/templates/new-product-details.html', {
              scope: $scope
          }).then(function(modal) {
              $scope.openNewProductDetailsModal = modal;
          });
         
          $scope.changeDesc = function ()
          {
              
              $scope.newproductdetails.Description = $scope.newproductdetails.Name;
          }
          
          $scope.closeProductDetailsModal = function(){
              $scope.openNewProductDetailsModal.hide();
              $scope.newproductdetails ={};
           }
            var valueExistOrUndefined = function(inputValue){
                 if(typeof inputValue == "undefined"  || inputValue == null || inputValue == "" )
                    return true;
                 else
                    return false;
            }
             $scope.SetModalDescriptionValues = function(){
               if(valueExistOrUndefined($scope.newproductdetails.Description))
                 productDetailsDataFctr.getProductDetails().Description = $scope.newproductdetails.Description = $scope.newproductdetails.Name;
             }

            // Search product code valid or not
          function checkProductCodeAvailibility(code)
          
          {
           var def = $q.defer();
            var url = $f.serviceUrl + "product/validate?ProductCode=" + code;
            var req = {
                method: 'get',
                url: url
            };
            errorFctr.specificallyHandled(function () {
                return $http(req)
                    .then(function (data) {
                        $scope.productCodeAvlbtyResponse = data.data;
                        def.resolve(data.data);
                        console.log(data);
                     }, function (error) {
                        console.log(error);
                        $scope.productCodeAvlbtyResponse = error.data;
                        def.reject(error);
                    });
            });
            console.log(def.promise);
            return def.promise;
        }

          $scope.closeProductDetailsModal = function(){
              $scope.openNewProductDetailsModal.hide();
              $scope.newproductdetails ={};
           }
          $scope.saveProductDetailsModal = function(data){
              $scope.param.searchterm = productDetailsDataFctr.getProductDetails().Name = $scope.newproductdetails.Name;
              $scope.param.department =  productDetailsDataFctr.getProductDetails().Department = $scope.newproductdetails.Department;
              productDetailsDataFctr.getProductDetails().Description = $scope.newproductdetails.Description;
              $scope.param.productcode = productDetailsDataFctr.getProductDetails().Code = $scope.newproductdetails.Code;
              console.log($scope.param.productcode);
              productDetailsDataFctr.setProductNameAndCode($scope.newproductdetails.Name,$scope.newproductdetails.Code);
              $ionicLoading.show({
                template: 'Valiating Details ...'
            });
            if(valueExistOrUndefined($scope.newproductdetails.Description) || valueExistOrUndefined($scope.newproductdetails.Code)
                || valueExistOrUndefined($scope.newproductdetails.Name) || valueExistOrUndefined($scope.newproductdetails.Department)){
                   $ionicLoading.hide();
                    popupFctr.alert('Please enter all values', 'Department, Name, Description & Product Code');
                  }
            else{
                     checkProductCodeAvailibility($scope.param.productcode).then(function () {
                          console.log("ProductCode is Available");
                          $scope.openNewProductDetailsModal.hide();
                          productDetailsDataFctr.setIsNewProduct(true);
                          var ele = document.getElementById('prodCode');
                          console.log(ele);
                           ele.style.outline="";
                           ele.style.color="";
                           var info = document.getElementById('errorInfo');
                           info.innerHTML="";
                           info.style.color="";
                            $ionicLoading.hide();
                  }, function () {
                      console.log("Oops Product Code Not Available");
                      var ele = document.getElementById('prodCode');
                      console.log(ele);
                       ele.style.outline="1px solid #ff0000";
                       ele.style.color="red";
                       var info = document.getElementById('errorInfo');
                       info.innerHTML="<p>Product Code not available , Please try a new one</p>";
                       info.style.color="red";

                      $ionicLoading.hide();
                  });
             }
          }

           /* Top bar recycle button evnet for clear all details */
            $scope.clear = function () {
                 init();typeof input !== "undefined"
            };
            /* function for handle all option pages natigation if product details exist */
            $scope.showFileProductInternalPages = function (pagename) {
               productDetailsDataFctr.setViewCountForBack(-1);
               if($scope.selectedProductInfo != null && !productDetailsDataFctr.getIsNewProduct()){
                   productDetailsDataFctr.setProductDetails($scope.selectedProductInfo);
                   productDetailsDataFctr.setIsNewProduct(false);
                   $state.go(pagename);

                 }
                else if(!_.isEmpty($scope.newproductdetails)){
                    productDetailsDataFctr.setIsNewProduct(true);
                    $state.go(pagename);
                }
                 else{
                     popupFctr.alert('Sorry', 'Please select a product or create a new one');
                }
          };
          /*Search Department for product finding or add new product details
          * searchby event params for finding or add product
          */
            $scope.searchby = null;
            $scope.searchDepartment = function (searchby) {
            $scope.searchby = searchby;
            $scope.param.limit=15;
            $scope.param.begin =0;
            $scope.copyBeginValue= 0;
            $ionicLoading.show({
                template:'wait...'
            })
            if(_.isEmpty($scope.departments)){
                departmentFctr.$LoadDepartments().then(
                function(data){
                    $scope.departments = [];
                    data =  _.sortBy( data, 'Name' );
                    _.each(data,function(department){
                      $scope.departments.push(department);
                     });
                    if($scope.departments.length>$scope.param.limit)
                      $scope.param.isNextDepAvailable = true;
                       $scope.filteredDepartments =  $scope.departments
                    //console.log(data);
                    $ionicLoading.hide();
                    $scope.departments_modal.show();
                    if($scope.param.department != "")
                    {
                      $scope.departments_modal.scope.$$childTail.param.departmentsearch = $scope.param.department;
                      $scope.departments_modal.scope.$$childTail.loadFilteredDepartments();
                    } else {
                      departmentFctr.$LoadDepartmentImages($scope.departments.slice($scope.param.begin,$scope.param.begin+$scope.param.limit));
                    }
                },function (error) {
                    popupFctr.alert('Not found', 'Product not found','barcodeInput');
                    $ionicLoading.hide();
                });
              } else {
                $scope.departments_modal.show();
                if($scope.param.department != ""){
                  $scope.departments_modal.scope.$$childTail.param.departmentsearch = $scope.param.department;
                  $scope.departments_modal.scope.$$childTail.loadFilteredDepartments();
                }
                $ionicLoading.hide();
            }
          }
        $scope.searchButtonEvent = function () {
            //debugger;
        }
        $scope.departments_modal = $ionicModal.fromTemplate('<div pos-departments></div>', {
            scope: $scope,
            animation: 'slide-in-up'
        });

        //This Function is called When a Department is Clicked in the Departments List
        $scope.loadProductsByDepID = function(id){
              $scope.param.selecteddepartment = _.findWhere($scope.departments,{ID: id});
               if($scope.param.selecteddepartment){
                  if($scope.searchby == "addnewproduct"){
                      $scope.newproductdetails = {};
                      $scope.newproductdetails.Department = $scope.param.selecteddepartment.Name;
                      $scope.openNewProductDetailsModal.show();
                  }
                  else {
                      $scope.param.department = $scope.param.selecteddepartment.Name;
                  }
                }
               $scope.departments_modal.hide();
        }

        $scope.clearDepartmentSelection = function(){
            $scope.param.department = '';
            $scope.param.searchterm = '';
            $scope.param.selecteddepartment = null;
            $scope.param.isNextDepAvailable = false;
            $scope.products = [];
            $scope.param.TotalFound = null;
            $scope.param.productcode = '';
            $scope.selectedProductInfo = null;
            productDetailsDataFctr.clearAllProductProductOption();
        }

        $scope.clearsearchproduct = function () {
             $scope.param.searchterm = '';
             $scope.param.isNextDepAvailable = false;
             $scope.products = [];
             $scope.param.TotalFound = null;
             $scope.selectedProductInfo = null;
        }

        $scope.clearproductcode = function () {
             $scope.param.productcode = '';
             $scope.param.isNextDepAvailable = false;
             $scope.products = [];
             $scope.param.TotalFound = null;
             $scope.selectedProductInfo = null;
        }

        // Search TextInput option
        $scope.search = function () {
          productDetailsDataFctr.clearAllProductProductOption();
          $scope.selectedProductInfo = null;
            //1. Check if department is Selected ,if Selected ,then a blank Search Would Invoke showing
            //    Products of Selected Department
            if( $scope.param.selecteddepartment && _.isEmpty($scope.param.searchterm)){
                //Do A Department Product LookUp just like we do in POS
                console.log("Dep products --");
                $scope.param.input = $scope.param.selecteddepartment.ID;
                $scope.param.mode = 6;
                $scope.param.store = $f.moduleSetting.Store.ID;
                $scope.param.MoreAvailable = false;
                $scope.param.TotalFound = null;
                $scope.param.page = 0;
                $scope.param.ExcludeDeactivated = true;
                $ionicLoading.show({
                    template: 'Searching...'
                });
                $scope.loadMore().then(function () {
                    $ionicLoading.hide();
                }, function () {
                    $ionicLoading.hide();
                });
            }

            else if (!_.isEmpty($scope.param.searchterm)) {
                document.getElementById("barcodeInput").blur();
                $scope.param.input = $scope.param.searchterm;
                $scope.param.store = $f.moduleSetting.Store.ID;
                $scope.param.MoreAvailable = false;
                $scope.param.mode = 0;
                $scope.param.TotalFound = null;
                $scope.param.page = 0;
                $scope.param.ExcludeDeactivated = true;
                $ionicLoading.show({
                    template: 'Searching...'
                });

                $scope.loadMore().then(function () {
                    $ionicLoading.hide();
                }, function () {
                    $ionicLoading.hide();
                });
            } else if ($scope.param.selecteddepartment == undefined && _.isEmpty($scope.param.searchterm)){
                popupFctr.alert('Invalid Search', 'Please enter a name, barcode or department');
            }
        };

        $scope.loadMore = function () {
            if ( $scope.param.input ) {
                $scope.param.page = $scope.param.page + 1;
                 return prodFctr.Retrieve.$search($scope.param)
                    .then(function (searchResult) {
                        prodSearchFctr.$genericSearchFromFileProductDetails($scope.param.input).then(function(result){
                          $ionicLoading.show({
                              template: 'wait...'
                          });
                          prodFctr.Retrieve.$load(result.ID).then(function (prodDetail) {
                              $ionicLoading.hide();
                              $scope.selectedProductInfo = prodDetail;
                              $scope.param.department=  prodDetail.Department.Name;
                              $scope.param.productcode = prodDetail.Code;
                              $scope.param.searchterm  = prodDetail.Name;
                              productDetailsDataFctr.setIsNewProduct(false);
                              productDetailsDataFctr.setProductNameAndCode(prodDetail.Name,prodDetail.Code);
                           });
                            //$scope.selectedProductInfo=result;
                        })
                        if ($scope.param.page <= 1) {
                            $scope.products = [];
                        }
                      if (!_.isEmpty(searchResult.Result)) {

                                $scope.param.TotalFound = searchResult.Total || searchResult.Result.length;
                                $scope.param.MoreAvailable = searchResult.MoreAvailable || false;
                                _.each(searchResult.Result, function (p) {
                                if (!_.isEmpty(p.images)) {
                                    p.image = p.images[0].value;
                                }
                                if(searchResult.Result.length == 1){
                                    $scope.products.push(p);
                                  //  $state.go('tab.product-detail',{'prodId': p.ID});
                                } else {
                                    $scope.products.push(p);
                                }
                            });
                        } else {
                            console.log("Product Not found");
                            popupFctr.alert('No results found', 'No results found for "' + $scope.param.searchterm + '"','barcodeInput');
                            var ele = document.getElementById("barcodeInput");
                            ele.setAttribute("focus-me-disable",false);


                            console.log(document.getElementById("barcodeInput"));
                        }
                        $scope.$broadcast('scroll.infiniteScrollComplete');
                    });
            }
        };
        init();

        function init() {
            $scope.selecteddepartment = "";
            $scope.filteredDepartments = [];
            $scope.searchDescription = "";
            $scope.advancedSearch = false;

              prodFctr.settings.$get('product').then(function (result) {
                  settings = result;
                  $scope.param = _.clone(prodFctr.Retrieve.SearchParam);
                  $scope.param.isNextDepAvailable = false;
                  $scope.param.isPrevDepAvailable = false;
                  $scope.products = [];
                  $scope.param.searchterm = "";
                  $scope.param.department = "";
                  $scope.param.productcode = "";
                  $scope.param.page = 0;
                  $scope.param.maxitems = settings.maxItems;
                  $scope.param.forceLoad = settings.forceLoad;
                  $scope.param.input = "";
                  $scope.param.includePictures = true;
                  $scope.param.MoreAvailable = false;
                  $scope.param.TotalFound = null;
                  $scope.param.isproductselected = false;
              });
        }

        function AdvancedDescription() {
            var Retval = [], params = [];
            var SearchParam = $scope.param;
            var addToParams = function (item) {
                if (!_.isEmpty(item)) {
                    params.push(item);
                }
            };

            addToParams(SearchParam.grids.grid1);
            addToParams(SearchParam.grids.grid2);
            addToParams(SearchParam.grids.grid3);
            addToParams(SearchParam.grids.grid4);

            if (!_.isEmpty(params.toString())) {
                Retval.push(params.toString());
            }

            var PriceText = '';
            if (_.isNumber(SearchParam.price_range.min)) {
                PriceText = PriceText + 'from ' + $filter('currency')(SearchParam.price_range.min) + ' ';
            }

            if (_.isNumber(SearchParam.price_range.max)) {
                PriceText = PriceText + 'up to ' + $filter('currency')(SearchParam.price_range.max);
            }

            PriceText = PriceText.trim();
            if (!_.isEmpty(PriceText)) {
                Retval.push(PriceText);
            }

            return Retval.join(" - ");;
        }
    }]);

        // make a factory to share data between controllers
  angular.module('aralco.productsDetails.controllers').factory('productDetailsDataFctr', function(){
          var isnewproduct = false;
          var backviewcount = -1;
          var setproductnameandcode = "";
          var productdetails = {Barcode:null,
                                Code:"",
                                CreatedBy:null,
                                Department: null,
                                Description:null,
                                GSTQuantity:null,
                                Grid1:null,
                                Grid2:null,
                                Grid3:null,
                                Grid4:null,
                                ID:null,
                                InvDecimals:null,
                                InventoryBy:null,
                                InventoryUnitID:null,
                                IsWeightedItem:false,
                                MSRP:null,
                                Matrix:null,
                                Name:"",
                                OrderBy:null,
                                OrderDecimals:null,
                                OrderUnitID:null,
                                Ordering:{DutyRateID:0,MinCompanyLevel:0,MaxCompanyLevel:0,LeadTime:0,StdOrderQuantity:0,ModelStock:null},
                                POS:{AlertFromDate:new Date(),AlertToDate:new Date()},
                                POSMultiplicator:null,
                                POSUnit:null,
                                POSUnitID:null,
                                PictureFile:null,
                                PointPlanID:null,
                                Pricing:{},
                                PrinterGroupID:null,
                                ProductGUID:null,
                                Properties:{DeactivateOrder:false,DeactivateSell:false,DeactivateInventory:false},
                                QtyDecimals:null,
                                RetailMultiplicator:null,
                                RetailPrice:null,
                                RetailPriceQty:null,
                                RetailPriceUnitID:null,
                                RetailUnit:null,
                                ScheduledService:false,
                                SellBy:null,
                                SoundFile:null,
                                SupplierID:null,
                                SupplierRemark:null,
                                Suppliers:null,
                                Taxes:[],
                                TypeInfo:{InventoryItem:true,SaleItem:true,SerialNumber:true,ShelfTag:true},
                                Unit:null,
                                UnitWeight:null,
                                Web:null,
                                hasGrid:false,
                                images:null,
                                version:null
                              };
           return {
             clearAllProductProductOption:function(){
               productdetails = null;
             },
             getIsNewProduct: function () {
               return isnewproduct;
             },
             setIsNewProduct: function (value) {
               return isnewproduct = value;
             },
             getProductDetails: function () {
               return productdetails;
             },
             setProductDetails: function (selectItems) {
               return productdetails = selectItems;
             },
             setProductNameAndCode:function (name,code) {
                setproductnameandcode = name+" ( "+code+" )";
             },
             getProductNameAndCode:function () {
                return setproductnameandcode;
             },
             setNextViewCountForBack:function(){
                  backviewcount = backviewcount -1;
                  if(backviewcount >= 0)
                    backviewcount= -1;
             },
             setPreviousViewCountForBack:function(){
                 if(backviewcount == -1)
                       backviewcount = backviewcount-1;
                  else if(backviewcount >= 0)
                        backviewcount = -1;
                  else
                      backviewcount = backviewcount + 1;

             },
             getViewCountForBack:function(){
                if(backviewcount >= 0)
                  return backviewcount = -1;
                else
                  return backviewcount;
             },
             setViewCountForBack :function(value){
               backviewcount = value;
             }
           }
        });
