angular.module('aralco.productsDetails.controllers')
.controller('ProdDetailsSupplierCtrl', ['productDetailsDataFctr','$http','$q','$scope', '$state','errorFctr', '$ionicSideMenuDelegate', '$ionicLoading', '$filter', '$ionicModal',
    function (productDetailsDataFctr,$http,$q, $scope, $state, errorFctr,$ionicSideMenuDelegate, $ionicLoading, $filter, $ionicModal) {


      var filters = [
             {
                 'filterId': 1,
                 'time': 'last 24 hours',
             },
             {
                 'filterId': 2,
                 'time': 'all',
             },
             {
                 'filterId': 3,
                 'time': 'last hour',
             },
             {
                 'filterId': 4,
                 'time': 'today',
             },
             {
                 'filterId': 5,
                 'time': 'yersteday',
             }
         ];

     $scope.filters = filters;
     $scope.selected = 0;

     $scope.select= function(index) {
        $scope.selected = index;
     };

       function supplierLookup() {
         $ionicLoading.show({
             template: 'Searching...'
         });
               var def = $q.defer();
               var url = $f.serviceUrl + "/supplier/get";
               var req = {
                   method: 'get',
                   url: url
               };
               errorFctr.specificallyHandled(function () {
                   return $http(req)
                       .then(function (data) {
                         $ionicLoading.hide();
                           def.resolve(data.data);

                             data.data.forEach(function(item){
                             if($scope.param.suppliersname !=""){
                                    if(item.Name.includes($scope.param.suppliersname))
                                        $scope.supplierLookupDatas.push(item);
                                }
                                 else{
                                   $scope.supplierLookupDatas.push(item);
                               }
                             });

                          //  data.data.forEach(function(item){
                          //    if(productlist!=null && productlist.Suppliers!=null && productlist.Suppliers.length > 0){
                          //       if($scope.param.suppliersname !=""){
                          //             if(item.Name.includes($scope.param.suppliersname))
                          //             {
                          //                if(_.where(productlist.Suppliers, {Id: item.Id}).length > 0 )
                          //                    $scope.supplierLookupDatas.push(data:item);
                          //                else
                          //
                          //               }
                          //           }
                          //           else {
                          //                 if(_.where(productlist.Suppliers, {Id: item.Id}).length > 0 )
                          //                      $scope.supplierLookupDatas.push(data:item);
                          //                 else
                          //                      $scope.supplierLookupDatas.push(data:item);
                          //           }
                          //        }
                          //        else {
                          //            if($scope.param.suppliersname !=""){
                          //                 if(item.Name.includes($scope.param.suppliersname))
                          //                 {
                          //                   $scope.supplierLookupDatas.push(data:item);
                          //                 }
                          //               }
                          //               else{
                          //                 $scope.supplierLookupDatas.push(data:item);
                          //             }
                          //           }
                          //  });
                       }, function (error) {
                           $ionicLoading.hide();
                           def.reject(error);
                       });
               });
               return def.promise;
       }
       $ionicModal.fromTemplateUrl('modules/product_details/templates/supplier-LookUp-modal.html', {
           scope: $scope
       }).then(function(modal) {
           $scope.openLookUpModal = modal;
       });
         $scope.param ={suppliersname:""};
       $scope.clearsuppliersname = function(){
          $scope.param.suppliersname ="";
       }
       $scope.SearchSuppliebyName = function(value){
         $scope.supplierLookupDatas =[];
         $scope.openLookUpModal.show();
         $scope.param.suppliersname = value;
         supplierLookup();
       }

        $scope.SaveSupplierSelectLookUp = function(){
          if(productDetailsDataFctr.getProductDetails().Suppliers.length == 0)
               $scope.supplierdata.isCheck = true;
          else
               $scope.supplierdata.isCheck =false;

          if(!_.where(productDetailsDataFctr.getProductDetails().Suppliers, {Id: $scope.supplierdata.Id}).length > 0 )
              productDetailsDataFctr.getProductDetails().Suppliers.push($scope.supplierdata);

          $scope.openLookUpModal.hide();
          $scope.selectSupplierList = productDetailsDataFctr.getProductDetails().Suppliers;
      }
       $scope.closeLookUp = function(){
           $scope.openLookUpModal.hide();
       }

      if(productDetailsDataFctr.getProductDetails().Suppliers == null)
           productDetailsDataFctr.getProductDetails().Suppliers = [];

       $scope.selectSupplierList = productDetailsDataFctr.getProductDetails().Suppliers;
       $scope.supplierremark  = productDetailsDataFctr.getProductDetails().SupplierRemark;
       $scope.supplierdata = null;
       $scope.active;

       $scope.selectedindex;
       $scope.supplierSelectForModel = function(supplierdata,value){
         $scope.supplierdata = supplierdata;
         $scope.active = value;
       }

       $scope.supplierSelect = function(supplierdata,value){
          $scope.selectedindex = value;
          for (var i = 0; i < $scope.selectSupplierList.length; i++) {
               if(i==value)
                    $scope.selectSupplierList[i].isCheck = true;
               else if($scope.selectSupplierList[i])
                    $scope.selectSupplierList[i].isCheck = false;
               else
                    $scope.selectSupplierList[i] = {isCheck:false};
          }
       }


        var removeItems = function (values) {
                    return productDetailsDataFctr.getProductDetails().Suppliers.filter(function( obj ) {
                      return obj.Id !== values.Id;
                    });
        };

       $scope.enterSupplierRemark = function(values){
             productDetailsDataFctr.getProductDetails().SupplierRemark = values;
       }

       $scope.nextView = function(){
          $state.go('tab.pricing');
          productDetailsDataFctr.setNextViewCountForBack();
     }

     $scope.previousView = function(){
        $state.go('tab.units');
        productDetailsDataFctr.setPreviousViewCountForBack();
   }
   $scope.searchproductcode = productDetailsDataFctr.getProductNameAndCode();
  }]);
