angular.module('aralco.productsDetails.controllers')
.controller('ProdDetailsUnitCtrl', ['productDetailsDataFctr','$http','$q','$scope', '$state','errorFctr', '$filter',
    function (productDetailsDataFctr,$http,$q, $scope, $state, errorFctr, $filter) {
                  $scope.unitID =0;
                  function executeUnitCategory() {
                          var def = $q.defer();
                          var url = $f.serviceUrl + "/unit/GetCategories";
                          var req = {
                              method: 'get',
                              url: url
                          };
                          errorFctr.specificallyHandled(function () {
                              return $http(req)
                                  .then(function (data) {
                                      def.resolve(data.data);
                                      $scope.unitCategorys=data.data;
                                      console.log($scope.unitCategorys);
                                       if($scope.filterunitCategorys == null && $scope.isviewdisabled)
                                         $scope.filterunitCategorys = $scope.unitCategorys[0].Code;
                                   }, function (error) {
                                      def.reject(error);
                                  });
                          });
                          return def.promise;
                  }

                 function executeOrderBy(id) {
                          var def = $q.defer();
                          var url = $f.serviceUrl + "/unit/ByCategory/" + id;
                          var req = {
                              method: 'get',
                              url: url
                          };
                          errorFctr.specificallyHandled(function () {
                              return $http(req)
                                  .then(function (data) {
                                      def.resolve(data.data);
                                      $scope.orderBydatas=data.data;
                                      if($scope.filterorderBydatas == null && $scope.isviewdisabled)
                                        $scope.filterorderBydatas =  $scope.orderBydatas[0].Code;
                                   }, function (error) {
                                      def.reject(error);
                                  });
                          });

                          return def.promise;
                  }

                 function executeInventryBy(id) {
                          var def = $q.defer();
                          var url = $f.serviceUrl + "/unit/ByCategory/" + id;
                          var req = {
                              method: 'get',
                              url: url
                          };
                          errorFctr.specificallyHandled(function () {
                              return $http(req)
                                  .then(function (data) {
                                      def.resolve(data.data);
                                      $scope.inventryBydatas=data.data;
                                      if($scope.filterinventryBydatas == null && $scope.isviewdisabled)
                                      $scope.filterinventryBydatas =  $scope.inventryBydatas[0].Code;
                                   }, function (error) {
                                      def.reject(error);
                                  });
                          });

                          return def.promise;
                  }
                 function executeSellBy(id) {
                          var def = $q.defer();
                          var url = $f.serviceUrl + "/unit/ByCategory/" + id;
                          var req = {
                              method: 'get',
                              url: url
                          };
                          errorFctr.specificallyHandled(function () {
                              return $http(req)
                                  .then(function (data) {
                                      def.resolve(data.data);
                                      $scope.sellBydatas=data.data;
                                      if($scope.filtersellBydata == null && $scope.isviewdisabled)
                                          $scope.filtersellBydatas = $scope.sellBydatas[0].Code;
                                     }, function (error) {
                                      def.reject(error);
                                  });
                          });
                        return def.promise;
                  }
        $scope.nextView = function(){
           $state.go('tab.supplier');
           productDetailsDataFctr.setNextViewCountForBack();

      }

      $scope.previousView = function(){
         $state.go('tab.tax');
        productDetailsDataFctr.setPreviousViewCountForBack();
    }
      executeUnitCategory();
      //executeOrderBy();
      //executeInventryBy();
      //executeSellBy();

      var productlist = productDetailsDataFctr.getProductDetails();
       $scope.searchproductcode = productDetailsDataFctr.getProductNameAndCode();
       $scope.isviewdisabled = false;
      if((productlist.Unit != null && productlist.Unit != "") || productDetailsDataFctr.getIsNewProduct())
      {
        $scope.isviewdisabled =true;
    //  $scope.filterunitCategorys = productlist.Unit;
      $scope.filterorderBydatas = productlist.OrderBy;
      $scope.orderbydecimals = productlist.OrderDecimals;
      $scope.filterinventryBydatas = productlist.InventoryBy;
      $scope.inventrybydecimals = productlist.InvDecimals;
      $scope.filtersellBydatas = productlist.SellBy;
      $scope.posqtyvalue = productlist.RetailPrice;
      $scope.posqtytype = productlist.RetailUnit;
      $scope.qtydecimals = productlist.QtyDecimals;
    }
    else {
     $scope.filterunitCategorys =[];
     $scope.filterorderBydatas = [];
     $scope.orderbydecimals = 0;
     $scope.filterinventryBydatas = [];
     $scope.inventrybydecimals = 0;
     $scope.filtersellBydatas = [];
     $scope.posqtyvalue = 0;
     $scope.posqtytype = [];
     $scope.qtydecimals = 0;
    }
   $scope.getUnitId = function(id)
    {
        $scope.unitID= id;
        console.log($scope.unitID);
    }
      $scope.unitItemChangeValue = function(option,value){
           switch (option) {
               case "unitcategory":
                   //debugger;
                    var input = JSON.parse(value);
                     productDetailsDataFctr.getProductDetails().Unit = input.Code;
                     executeOrderBy(input.ID);
                     executeInventryBy(input.ID);
                     executeSellBy(input.ID);


               break;
               case "orderby":
                   var input = JSON.parse(value);
                   productDetailsDataFctr.getProductDetails().OrderBy = input.Code;
               break;
               case "orderbydecimals":
                    var input = JSON.parse(value);
                   productDetailsDataFctr.getProductDetails().OrderDecimals = input.Code;
                 break;
                 case "inventryby":
                  var input = JSON.parse(value);
                     productDetailsDataFctr.getProductDetails().InventoryBy = input.Code;
                  break;
                  case "inventrybydecimals":
                    var input = JSON.parse(value);
                       productDetailsDataFctr.getProductDetails().InvDecimals = input.Code;
                 break;
                 case "sellby":
                    var input = JSON.parse(value);
                     productDetailsDataFctr.getProductDetails().SellBy = input.Code;
                 break;
                 case "posqtyvalue":
                     productDetailsDataFctr.getProductDetails().RetailPrice = value;
                 break;
                 case "posqtytype":
                     productDetailsDataFctr.getProductDetails().RetailUnit = value;
                 break;
                 case "decimalsqty":
                     productDetailsDataFctr.getProductDetails().QtyDecimals = value;
                 break;
             default:
           }
        }

  }]);
