angular.module('aralco.productsDetails.controllers')
.controller('PropertiesCtrl', ['$q','$http','errorFctr','$scope', '$state', '$ionicSideMenuDelegate', '$ionicLoading', '$filter', '$ionicPopover', '$ionicModal','localStorageService',
        function ($q,$http,errorFctr,$scope, $state, $ionicSideMenuDelegate, $ionicLoading, $filter, $ionicPopover, $ionicModal,localStorageService) {

	$ionicModal.fromTemplateUrl('modules/product_details/templates/pick-value-modal.html', {
	    scope: $scope
  	}).then(function(modal) {
    	$scope.picValueModal = modal;
  	});

	$scope.openPickValues = function(){
		$scope.picValueModal.show();
	}

	$scope.closePickValues = function(){
		$scope.picValueModal.hide();
	}

	$ionicModal.fromTemplateUrl('modules/product_details/templates/barcode-grid-modal.html', {
	    scope: $scope
  	}).then(function(modal) {
    	$scope.barcodeGridModal = modal;
  	});
  	$scope.openBarcodeGrid = function(){
		$scope.barcodeGridModal.show();
	}
	$scope.closeBarcodeGrid = function(){
		$scope.barcodeGridModal.hide();
	}
	$ionicModal.fromTemplateUrl('modules/product_details/templates/system-generated-grid-modal.html', {
	    scope: $scope
  	}).then(function(modal) {
    	$scope.systemGeneratedGridModal = modal;
  	});
  	$scope.openSystemGeneratedGrid = function(){
		$scope.systemGeneratedGridModal.show();
	}
	$scope.closeSystemGeneratedGrid = function(){
		$scope.systemGeneratedGridModal.hide();
	}


	var user = localStorageService.get($f.CONSTANT.USER_INFO);
	function propertiesGridDim1() {
                    var def = $q.defer();
                    var url = $f.serviceUrl + "/dimension/get";
                    var req = {
                        method: 'get',
                        url: url
                    };
                    errorFctr.specificallyHandled(function () {
                        return $http(req)
                            .then(function (data) {
                                def.resolve(data.data);
                                $scope.propertiesGridDim1Datas=data.data;
                                $scope.filterpropertiesGridDim1Datas =  $scope.propertiesGridDim1Datas[0].Name;
                            }, function (error) {
                                def.reject(error);
                            });
                    });

                    return def.promise;
      }
      function propertiesBarcodesBarcodeSet() {
                    var def = $q.defer();
                    var url = $f.serviceUrl + "/product/GetBarcodeSets";
                    var req = {
                        method: 'get',
                        url: url
                    };
                    errorFctr.specificallyHandled(function () {
                        return $http(req)
                            .then(function (data) {
                                def.resolve(data.data);
                                $scope.propertiesBarcodesBarcodeSetDatas=data.data;
                                $scope.filterpropertiesBarcodesBarcodeSetDatas =  $scope.propertiesBarcodesBarcodeSetDatas[0].Name;
                            }, function (error) {
                                def.reject(error);
                            });
                    });

                    return def.promise;
      }
      function propertiesGridDim1Details() {
                    var def = $q.defer();
                    var url = $f.serviceUrl + "/dimension/detail/1468";
                    var req = {
                        method: 'get',
                        url: url
                    };
                    errorFctr.specificallyHandled(function () {
                        return $http(req)
                            .then(function (data) {
                                def.resolve(data.data);
                                $scope.propertiesGridDim1DetailsDatas=data.data.Grids;

                            }, function (error) {
                                def.reject(error);
                            });
                    });

                    return def.promise;
      }



      propertiesGridDim1();
      propertiesBarcodesBarcodeSet();
      propertiesGridDim1Details();
    $scope.searchproductcode = productDetailsDataFctr.getProductNameAndCode();  

}]);
