angular.module('aralco.security').factory('securityFctr', 
['$q', '$http', 
function ($q, $http) {
    this.SecurityAccess = function (accessCode, areaName) {
        /// <summary>
        /// Load list of registers
        /// </summary>
        /// <param name="id">Store ID</param>
        var deferred = $q.defer();
        var paramsValues =  {
            "Employee": {
                "ID": $f.UserInfo.EmployeeID,
                "Login": $f.UserInfo.UserLogin,
                "Name": $f.UserInfo.FirstName
            },
            
            "AccessCode": accessCode,
            "AllowOtherLogin" : false,
            "WarnWhenDenied": true,
            "AreaName": areaName
        }
        var url = $f.serviceUrl + 'license/SecurityAccess';
        var req = {
            method: 'post',
            url: url,
            data:paramsValues
        }


        $http(req).
          success(function (data, status, headers, config) {
              deferred.resolve(data)
          }, function (data, status) {
              deferred.reject(data, status);
          });

        return deferred.promise;
    }

    return this;
 }]);