(function () {

    var module = angular.module('aralco.possetup',['ionic']);

    module.config(['$stateProvider', '$provide', '$urlRouterProvider',
    '$httpProvider', function ($stateProvider, $provide, $urlRouterProvider, $httpProvider) {

        $stateProvider

        .state('tab.possetup', {
            url: '/possetup',
            LoginRequired: true,
            views: {
                'tab-view': {
                    templateUrl: 'modules/setup_option_pos/templates/tab-pos-setup-option.html',
                    controller: 'possetupCtr'
                }
            }
        });



    }]);
   

    module.controller("possetupCtr", ['$scope', 'deviceFctr','$filter','APP_ABOUT', function ($scope, deviceFctr,$filter,APP_ABOUT) {
           
        $scope.viewMenu = [];

        $scope.viewMenu.push(new MenuItem("Design Invoice", "ion-clipboard", "", 'View products and inventories'));
        $scope.viewMenu.push(new MenuItem("Discount Reasons", "ion-bag", "#/tab/discountreasons", 'Access to the list of of stores'));
        $scope.viewMenu.push(new MenuItem("Return Reasons", "ion-arrow-return-left", "#/tab/returnreasons", 'Access to the list of of registers'));
        $scope.viewMenu.push(new MenuItem("Expenses", "ion-cash", "#/tab/expenses", 'Access to the list of your customers'));
        $scope.viewMenu.push(new MenuItem("POS Settings", "ion-settings", "#/tab/staffs", 'Staff form'));
        $scope.viewMenu.push(new MenuItem("Tender Key Setup", "ion-key", "#/tab/tenderkeysetup", 'Suppliers form'));
        $scope.viewMenu.push(new MenuItem("Salutation", "ion-document-text", "#/tab/possalutations", 'Suppliers form'));
        $scope.viewMenu.push(new MenuItem("Points Plans", "ion-android-more-vertical", "#/tab/pointsplan", 'Suppliers form'));
        $scope.viewMenu.push(new MenuItem("Staff Hours", "ion-clock", "#/tab/bossetup", 'Suppliers form'));
        $scope.viewMenu.push(new MenuItem("Staff Schedules", "ion-calendar", "#/tab/bossetup", 'Suppliers form'));
        $scope.viewMenu.push(new MenuItem("Gift Cards", "ion-card", "#/tab/giftcards", 'Suppliers form'));
        $scope.viewMenu.push(new MenuItem("Coupons", "ion-pricetags", "#/tab/coupons", 'Suppliers form'));
        $scope.viewMenu.push(new MenuItem("Item Menu Design", "ion-navicon-round", "#/tab/bossetup", 'Suppliers form'));
        $scope.viewMenu.push(new MenuItem("Printer Groups", "ion-printer", "#/tab/bossetup", 'Suppliers form'));
        $scope.viewMenu.push(new MenuItem("Remarks Options", "ion-document-text", "#/tab/remarkoptions", 'Suppliers form'));
        
        function MenuItem(text, icon, url, description) {            
            return {
                text: text,
                icon: icon,
                url: url,
                description: description
            };
        }
        
    }])    

})();